/****************************************************************************
  FILE: Event.h
  PURPOSE: Tango API
 ***************************************************************************/


#ifndef __H_EVENT__
#define __H_EVENT__


#include <winsock.h>


#define CONTROL 30
#define DATA    31
#define PING    51


struct Event
{
    int type;
    int len;
    char *data;
};


#ifdef __cplusplus
extern "C" {
#endif

SOCKET registerApp(int argc,char *argv[] );
SOCKET registerWinApp(LPSTR lpCmdLine);
HRESULT sendEvent(SOCKET sockfd,struct Event *pev );
struct Event *receiveEvent(SOCKET sockfd);
struct Event *createEvent(int type,int len,char *data);
int getType(struct Event *pev);
int getLen(struct Event *pev);
char *getData(struct Event *pev);
void destroyEvent(struct Event *pev);

#ifdef __cplusplus
}
#endif


#endif /*__H_EVENT__*/


