package java.awt;
import java.awt.event.*;
import java.util.*;

class QueueStarter extends Thread
  {
    AppletEventQueue assQueue;
    Hashtable h0;
    public QueueStarter(ThreadGroup thg,AppletEventQueue assQueue)
      {
	super(thg,"Starter thread");
	this.assQueue=assQueue;
      }
    public void run()	
      {
	TangoEventQueue.h0.put(getThreadGroup(),new AppletEventQueue(assQueue));
	
	synchronized( TangoEventQueue.h0 )
	  {
	    TangoEventQueue.h0.notifyAll();
	  };
      }
  }

public class TangoEventQueue extends EventQueue
{
  static Hashtable h0=new Hashtable();
  static Hashtable h1=new Hashtable();
  static Hashtable h2=new Hashtable();
  static WindowAdapter wl;
  static WindowAdapter dl;
  static ComponentAdapter cl;
  static Object sema=new Object();

  
  
  public static void registerThreadGroup(ThreadGroup thg)
    {
      (new QueueStarter(thg,null)).start();
    }
  public static void registerWindow(Window w)
    {
      synchronized(sema)
	{
	  ThreadGroup thg=Thread.currentThread().getThreadGroup();
	  EventQueue eq=null;
	  while(thg!=null && (eq=(AppletEventQueue)h0.get(thg))==null)
	    thg=thg.getParent();
	  if(eq!=null)
	    h1.put(w,eq);
	  w.addWindowListener(wl);
	}
    }
  public static void registerDialog(Dialog d)
    {
      synchronized(sema)
	{
	  AppletEventQueue eq;
	  ThreadGroup thg=Thread.currentThread().getThreadGroup();
	  while(thg!=null && (h0.get(thg))==null)
	    thg=thg.getParent();
	  ThreadGroup thg1=new ThreadGroup(thg.getName()+":Dialog");
	  (new QueueStarter(thg1,(AppletEventQueue)h0.get(thg))).start();
	  synchronized(h0)
	    {
	      while((eq=(AppletEventQueue)h0.get(thg1))==null)
		{
		  try
		    {
		      h0.wait();
		    }
		  catch(Exception e)
		    {
		      e.printStackTrace();
		    }
		}
	    }
	  h1.put(d,eq);
	  d.addWindowListener(dl);
	  if(d.isModal())
	    {
	      d.setModal(false);
	      d.addComponentListener(cl);
	    }
	}
    }
  public static void registerMenuComponent(MenuComponent c)
    {
      synchronized(sema)
	{
	  ThreadGroup thg=Thread.currentThread().getThreadGroup();
	  EventQueue eq=null;
	  while(thg!=null && (eq=(AppletEventQueue)h0.get(thg))==null)
	    thg=thg.getParent();
	  if(eq!=null)
	    h2.put(c,eq);
	}
    }


  public static void closingApplet(ThreadGroup tg)
    {
      System.out.println("Closing applet:"+tg);
      synchronized(sema)
	{
	  ThreadGroup thg=tg;
	  EventQueue eq=null;
	  Hashtable h3=new Hashtable();
	  Hashtable h4=new Hashtable();
	  while(thg!=null && (eq=(EventQueue)h0.get(thg))==null)
	    thg=thg.getParent();
	  if(eq!=null)
	    {
	      h0.remove(thg);
	      for(Enumeration e=h1.keys();e.hasMoreElements();)
		{
		  Window w=(Window)e.nextElement();
		  if(h1.get(w)==eq)
		    {
		      if(w.isShowing())
			w.dispose();
		    }
		  else
		    h3.put(w,h1.get(w));
		}
	      h1.clear();
	      h1=h3;
	      for(Enumeration e=h2.keys();e.hasMoreElements();)
		{
		  Object o=e.nextElement();
		  if(h2.get(o)!=eq)
		    h4.put(o,h2.get(o));
		}
	      h2.clear();
	      h2=h4;
	    }
	  if(thg!=null)
	    h0.remove(thg);
	}
    }

  public TangoEventQueue()
    {
      super();
      wl=new WindowAdapter()  {
	public void windowClosed( WindowEvent we)
	  {
	    h1.remove(we);
	  }
      };
	
      dl=new WindowAdapter()  {
	public void windowClosed(WindowEvent e)
	  {
	    System.out.println("DialogClosed");
	    AppletEventQueue eq=(AppletEventQueue)h1.get(e.getSource());
	    h1.remove(e.getSource());
	    for(Enumeration en=h0.keys();en.hasMoreElements();)
	      {
		Object key=en.nextElement();
		if(h0.get(key)!=eq) continue;
		h0.remove(key);
		((ThreadGroup)key).stop();
		return;
	      }
	  }
      };
      
      cl=new ComponentAdapter()	{
	public void componentShown(ComponentEvent ce)
	  {
	    System.out.println("DialogShown");
	    AppletEventQueue eq=(AppletEventQueue)h1.get(ce.getSource());
	    eq.associatedQueue.suspend();
	  }
	public void componentHidden(ComponentEvent ce)
	  {
	    System.out.println("DialogHidden");
	    AppletEventQueue eq=(AppletEventQueue)h1.get(ce.getSource());
	    eq.associatedQueue.resume();
	  }
      };
    }

  int counter=0;
  public void postEvent(AWTEvent theEvent)
    {
      ThreadGroup thg=Thread.currentThread().getThreadGroup();
      EventQueue eq=null;
      if(theEvent.getSource() instanceof Component)
	{
	 
	  Component c=(Component)theEvent.getSource();
	  while(c!=null && !(c instanceof Window))
	    c=c.getParent();
	  if(c!=null)
	    {
	      Window w=(Window)c;
	      eq=(EventQueue)h1.get(w);
	      if(eq!=null)
		{
		  eq.postEvent(theEvent);
		  return;
		}
	    }
	}
      if(theEvent.getSource() instanceof MenuComponent)
	{
	  MenuComponent c=(MenuComponent)theEvent.getSource();
	  eq=(EventQueue)h2.get(c);
	  if(eq!=null) eq.postEvent(theEvent);
	  return;
	}
      while(thg!=null && (eq=(EventQueue)h0.get(thg))==null)
	thg=thg.getParent();
      if(eq!=null)
	{
	  eq.postEvent(theEvent);
	  return;
	}
      super.postEvent(theEvent);
    }
  public synchronized AWTEvent getNextEvent() throws InterruptedException
    {
      ThreadGroup thg=Thread.currentThread().getThreadGroup();
      EventQueue eq=null;
      while(thg!=null && (eq=(EventQueue)h0.get(thg))==null)
	thg=thg.getParent();
      if(eq!=null)
	return eq.getNextEvent();
      return super.getNextEvent();
    }
  public synchronized AWTEvent peekEvent()
    {
      ThreadGroup thg=Thread.currentThread().getThreadGroup();
      EventQueue eq=null;
      while(thg!=null && (eq=(EventQueue)h0.get(thg))==null)
	thg=thg.getParent();
      if(eq!=null)
	return eq.peekEvent();
      return super.peekEvent();
    }
  public synchronized AWTEvent peekEvent(int id)
    {
      ThreadGroup thg=Thread.currentThread().getThreadGroup();
      EventQueue eq=null;
      while(thg!=null && (eq=(EventQueue)h0.get(thg))==null)
	thg=thg.getParent();
      if(eq!=null)
	return eq.peekEvent(id);
      return super.peekEvent(id);
    }
}





