package java.awt;

import java.util.Properties;
import java.awt.peer.*;
import java.awt.image.ImageObserver;
import java.awt.image.ImageProducer;
import java.awt.image.ColorModel;
import java.awt.datatransfer.Clipboard;
import java.net.URL;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.awt.*;

public class TangoToolkit extends Toolkit
{
  public ButtonPeer 	createButton(Button target) { return dft.createButton(target); }
  public TextFieldPeer 	createTextField(TextField target) { return dft.createTextField(target); }
  public LabelPeer 	createLabel(Label target) {return dft.createLabel(target) ;}
  public ListPeer 	createList(List target){return dft.createList(target) ;}
  public CheckboxPeer 	createCheckbox(Checkbox target){return dft.createCheckbox(target) ;}
  public ScrollbarPeer 	createScrollbar(Scrollbar target){return dft.createScrollbar(target) ;}
  public ScrollPanePeer createScrollPane(ScrollPane target){return dft.createScrollPane(target) ;}
  public TextAreaPeer  	createTextArea(TextArea target){return dft.createTextArea(target) ;}
  public ChoicePeer	createChoice(Choice target){return dft.createChoice(target) ;}
  public FramePeer  	createFrame(Frame target)
    {
      TangoEventQueue.registerWindow(target);
      return dft.createFrame(target) ;
    }
  public WindowPeer  	createWindow(Window target)
    {
      TangoEventQueue.registerWindow(target);
      return dft.createWindow(target) ;
    }
  public DialogPeer  	createDialog(Dialog target)
    {
      TangoEventQueue.registerDialog(target);
      return dft.createDialog(target) ;
    }
  public CanvasPeer 	createCanvas(Canvas target){return dft.createCanvas(target) ;}
  public PanelPeer  	createPanel(Panel target){return dft.createPanel(target) ;}
  public MenuBarPeer  	createMenuBar(MenuBar target)
    {
      TangoEventQueue.registerMenuComponent(target);
      return dft.createMenuBar(target) ;
    }
  public MenuPeer  	createMenu(Menu target)
    {
      TangoEventQueue.registerMenuComponent(target);
      return dft.createMenu(target) ;
    }
  public PopupMenuPeer	createPopupMenu(PopupMenu target)
    {
      TangoEventQueue.registerMenuComponent(target);
      return dft.createPopupMenu(target) ;
    }
  public MenuItemPeer  	createMenuItem(MenuItem target)
    {
      TangoEventQueue.registerMenuComponent(target);
      return dft.createMenuItem(target) ;
    }
  public FileDialogPeer	createFileDialog(FileDialog target)
    {
      TangoEventQueue.registerDialog(target);
      return dft.createFileDialog(target);
    }
  public CheckboxMenuItemPeer	createCheckboxMenuItem(CheckboxMenuItem target)
    { 
      TangoEventQueue.registerMenuComponent(target);
      return dft.createCheckboxMenuItem(target);
    }
  public java.awt.peer.LightweightPeer createComponent(Component target) { return dft.createComponent(target);}
  public FontPeer getFontPeer(String name, int style){return dft.getFontPeer( name, style) ;}
  public void loadSystemColors(int[] systemColors) { dft.loadSystemColors(systemColors); }
  public Dimension getScreenSize(){return dft.getScreenSize() ;}
  public int getScreenResolution(){return dft.getScreenResolution() ;}
  public ColorModel getColorModel(){return dft.getColorModel() ;}
  public String[] getFontList(){return dft.getFontList() ;}
  public FontMetrics getFontMetrics(Font font){ return dft. getFontMetrics(font);}
  public void sync(){ dft.sync();}

  static Toolkit dft;
  public static void init()
    {
      String nm=System.getProperty("awt.toolkit","sun.awt.motif.MToolkit");
      System.getProperties().put("awt.toolkit","java.awt.TangoToolkit");
      try
	{
	  dft=(Toolkit)Class.forName(nm).newInstance();
	}
      catch (ClassNotFoundException e)
	{
	  throw new AWTError("Toolkit not found: " + nm);
	}
      catch (InstantiationException e)
	{
	  throw new AWTError("Could not instantiate Toolkit: " + nm);
	}
      catch (IllegalAccessException e)
	{
	  throw new AWTError("Could not access Toolkit: " + nm);
	}
    }
  
  public Image getImage(String filename){ return dft.getImage(filename);}
  public Image getImage(URL url){ return dft.getImage(url);}
  public boolean prepareImage(Image image, int width, int height,
				       ImageObserver observer){ return dft.prepareImage(image,width,height,observer);}
  public int checkImage(Image image, int width, int height,
				 ImageObserver observer){ return dft.checkImage(image,width,height,observer);}
  public Image createImage(ImageProducer producer){ return dft.createImage(producer);}
  public Image createImage(byte[] imagedata) { return dft.createImage(imagedata); }
  public Image createImage(byte[] imagedata,
				    int imageoffset,
				    int imagelength){return dft.createImage(imagedata,imageoffset,imagelength) ;}
  public PrintJob getPrintJob(Frame frame, String jobtitle, Properties props){ return dft.getPrintJob(frame,jobtitle,props);}
  public void beep(){ dft.beep();}
  public Clipboard getSystemClipboard(){ return dft.getSystemClipboard();}
  public int getMenuShortcutKeyMask() { return dft.getMenuShortcutKeyMask(); }
  public EventQueue getSystemEventQueueImpl()
    {
      return dft.getSystemEventQueueImpl();
    }
}
