create table users 
	( u_id NUMBER CONSTRAINT pk_users_uid PRIMARY KEY,
	  ulogin VARCHAR2(32) CONSTRAINT nn_users_login NOT NULL
			CONSTRAINT un_users_login UNIQUE,
	  upass  VARCHAR2(32) CONSTRAINT nn_users_pass NOT NULL,
	  descr VARCHAR2(2000));

create table communities
	( cid  NUMBER CONSTRAINT pk_community_cid PRIMARY KEY,
	  name VARCHAR2(255),
	  description VARCHAR2(2000));

create table community_access
	( u_id,
	  cid,
	  acctype CHAR(1),
	  CONSTRAINT un_community_access PRIMARY KEY (u_id,cid),
	  CONSTRAINT fk_community_access_uid FOREIGN KEY (u_id) REFERENCES users(u_id),
	  CONSTRAINT fk_community_access_cid FOREIGN KEY (cid) REFERENCES communities(cid) );

create table user_data
	( u_id,
	  key VARCHAR2(700) CONSTRAINT nn_user_data_key NOT NULL,
	  value LONG RAW,
	  CONSTRAINT pk_user_data PRIMARY KEY (u_id,key),
	  CONSTRAINT fk_user_data_uid FOREIGN KEY (u_id) REFERENCES users(u_id) );

create table registry_global
	(
	  key VARCHAR2(700) CONSTRAINT pk_registry_global PRIMARY KEY,
	  value LONG RAW );

create table registry_community
	(
	  cid,
	  key VARCHAR2(700) CONSTRAINT nn_registry_community_key NOT NULL,
	  value LONG RAW,
	  CONSTRAINT fk_registry_community_cid FOREIGN KEY (cid) REFERENCES communities(cid),
	  CONSTRAINT pk_registry_community PRIMARY KEY (cid,key) );

create table registry_user
	(
	  u_id,
	  key VARCHAR2(700) CONSTRAINT nn_registry_user_key NOT NULL,
	  value LONG RAW,
	  CONSTRAINT fk_registry_user_uid FOREIGN KEY (u_id) REFERENCES users(u_id),
	  CONSTRAINT pk_registry_user PRIMARY KEY (u_id,key) );
	  
create unique index i_users on users(ulogin,upass);

create sequence community_seq;
create sequence user_seq;
