package webwisdom.pure;

import sun.audio.*;
import java.applet.AudioClip;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;

public synchronized class AppletAudioClip implements AudioClip
{
    URL url;
    AudioData data;
    InputStream stream;

    public AppletAudioClip(URL uRL)
    {
        InputStream inputStream;
        inputStream = null;
        try
        {
	  URLConnection uRLConnection = uRL.openConnection();
	  uRLConnection.setAllowUserInteraction(true);
	  inputStream = uRLConnection.getInputStream();
	  data = new AudioStream(inputStream).getData();
	  if (inputStream != null)
	    inputStream.close();
        }
	catch(Exception e)
	  {
	  }
        return;
    }

    public AppletAudioClip(byte ab[])
    {
        data = new AudioData(ab);
    }

    public synchronized void play()
    {
        stop();
        if (data != null)
        {
            stream = new AudioDataStream(data);
            AudioPlayer.player.start(stream);
        }
    }

    public synchronized void loop()
    {
        stop();
        if (data != null)
        {
            stream = new ContinuousAudioDataStream(data);
            AudioPlayer.player.start(stream);
        }
    }

    public synchronized void stop()
    {
        if (stream == null)
	  return;
        AudioPlayer.player.stop(stream);
        try
        {
            stream.close();
        }
        catch (IOException e)
        {
            return;
        }
        return;
    }

    public String toString()
    {
        return "[" + url + "]";
    }
}



