package webwisdom.pure;

import java.net.*;
import java.io.*;
import java.util.*;

public class TClassLoader extends ClassLoader
{
  Hashtable 		rawClasses=new Hashtable();
  Hashtable		classes=new Hashtable();
  Vector 		archives=new Vector();
  TResourceLoader 	resources;
  URL			base;
  Thread 		thread;

  public URL getCodeBase()
    {
      return base;
    }
  public TClassLoader(URL u)
    {
      base=u;
      resources=new TResourceLoader(this);
    }
  public TResourceLoader getResourceLoader()
    {
      return resources;
    }
  private Class loadClass(String string, URL url) throws Exception
    {
      InputStream is=null;
      byte ab1[]=null;
      int j=0,k=0;
      try
	{
	  URLConnection urlc=url.openConnection();
	  urlc.setAllowUserInteraction(false);
	  //	  is=sun.net.www.protocol.http.HttpURLConnection.openConnectionCheckRedirects(urlc);
	  is=urlc.getInputStream();
	  int i=urlc.getContentLength();
	  ab1=new byte[(i==-1)?4096:i];
	  thread=Thread.currentThread();
	}
      catch(Exception e)
	{
	}
      while((k=is.read(ab1,j,ab1.length-j))>=0 && !thread.isInterrupted())
	{
	  j=j+k;
	  if(j>=ab1.length)
	    {
	      byte ab2[]=new byte[j*2];
	      System.arraycopy(ab1,0,ab2,0,j);
	      ab1=ab2;
	    }
	}
      if(thread.isInterrupted())
	throw new Exception("Applet Loading interrupted");
      java.lang.Class cl=defineClass(string,ab1,0,j);
      return cl;
    }
    

  public Class loadClass(String string) throws ClassNotFoundException
    {
      return loadClass(string,true);
    }
    
  protected Class loadClass(String name,boolean resolve) throws ClassNotFoundException
    {
      //      System.out.println("Loading class:"+name);
      Class cl=null;
      try
	{
	  cl=findLoadedClass(name);
	  if(cl==null)
	    {
	      try
		{
		  return findSystemClass(name);
		}
	      catch(ClassNotFoundException e)
		{
		  cl=findClass(name);
		}
	    }
	  if(resolve)
	    resolveClass(cl);
	}
      catch(Exception e)
	{
	}
      if(cl==null)
	throw new ClassNotFoundException(name);
      return cl;
    }

  Class findClass(String s) throws Exception
    {
      Class c=(Class)classes.get(s);
      if(c==null)
	{
	  byte b[]=(byte[])rawClasses.get(s);
	  if(b!=null)
	    {
	      c=defineClass(b,0,b.length);
	      classes.put(s,c);
	      rawClasses.remove(s);
	    }
	}
      if(c==null)
	{
	  String s2=s.replace('.', '/')+".class";
	  URL u=new URL(base,s2);
	  c=loadClass(s,u);
	  classes.put(s,c);
	}
      return c;
    }
  
  String defineClassFromBytes(String s,byte ba[],int b,int o)
    {
      //System.out.println("Defining class:"+s);
      rawClasses.put(s,ba);
      return s;
    }
  
  /*  public URL getResource(String name)
    {
      try
	{
	  URL u=resources.getResource(name);
	  if(u!=null) return u;
	}
      catch(Exception e)
	{
	}
      return super.getResource(name);
    }
  public InputStream getResourceAsStream(String name)
    {
      try
	{
	  InputStream is=resources.getResourceAsStream(name);
	  if(is!=null) return is;
	}
      catch(Exception e)
	{
	}
      return super.getResourceAsStream(name);
    }*/
}




