package webwisdom.pure;

import java.io.*;
import java.net.*;
import java.applet.*;
import java.awt.*;
import java.util.*;
import java.util.zip.*;
import sun.misc.Ref;
import sun.tools.jar.*;
import java.awt.*;
import sun.awt.image.URLImageSource;

class TResourceLoader
{
  Hashtable audioHash=new Hashtable();
  Hashtable resourceHash=new Hashtable();
  Hashtable mimeHash=new Hashtable();
  TClassLoader loader;

  TResourceLoader(TClassLoader l)
    {
      loader=l;
    }
  void loadJar(URL base,String str) throws Exception
    {
      InputStream is;
      URL url=new URL(base,str);
      //System.out.println("ZIP:"+url);
      URLConnection urlCon = url.openConnection();
      try
	{
	  //is=sun.net.www.protocol.http.HttpURLConnection.openConnectionCheckRedirects(urlCon);
	  is=urlCon.getInputStream();
	}
      catch(Exception e)
	{
	  is=urlCon.getInputStream();
	}
      
      Hashtable hashtable=new Hashtable();
      byte ab1[]=new byte[8192];
      ByteArrayOutputStream baos=new ByteArrayOutputStream(2048);
      ZipInputStream zis=null;
      try
	{
	  zis=new ZipInputStream(is);
	  for(ZipEntry zipEntry=null;(zipEntry=zis.getNextEntry())!=null;)
	    {
	      int i;
	      Object robj=null;
	      String name=zipEntry.getName();
	      String man_type=null;
	      baos.reset();
	      while((i=zis.read(ab1,0,ab1.length)) != -1)
		baos.write(ab1,0,i);
	      byte ab2[]=baos.toByteArray();
	      if(man_type==null)
		man_type=guessManifestType(name);
	      if(man_type==null)
		{
		  ByteArrayInputStream bis=new ByteArrayInputStream(ab2);
		  man_type=URLConnection.guessContentTypeFromStream(bis);
		}
	      if(man_type==null)
		man_type="input-stream/input-stream";
	      if(man_type.startsWith("image"))
		{
		  putLocalResource(new URL(url,name),ab2,man_type);
		}
	      else if(man_type.startsWith("audio"))
		{
		  putLocalResource(new URL(url,name),ab2,man_type);
		  AppletAudioClip aac=new AppletAudioClip(ab2);
		  audioHash.put(new URL(url,name),aac);
		  robj=aac;
		}
	      else if(man_type.startsWith("application/java-vm") ||
		      man_type.startsWith("application/x-java-vm"))
		{
		  markLocalClass(new URL(url,name));
		  String s=name.substring(0,name.length()-6).replace('/','.');
		  String tClassEntry=loader.defineClassFromBytes(s,ab2,0,ab2.length);
		  robj=tClassEntry;
		}
	      else if(!man_type.equals("manifest/manifest") &&
		      !man_type.equals("manifest/signature-bin"))
		putLocalResource(new URL(url,name),ab2,man_type);
	      if(robj!=null)
		hashtable.put(name,robj);
	    }
	}
      catch(Exception e)
	{
	  e.printStackTrace();
	}
    }
  String guessManifestType(String string)
    {
      string = string.toUpperCase();
      if (string.startsWith("/"))
	string = string.substring(1);
      if (!string.startsWith("META-INF/"))
	return null;
      if (string.equalsIgnoreCase("META-INF/MANIFEST.MF"))
	return "manifest/manifest";
      if (string.endsWith("DSA") || string.endsWith("PK7") || string.endsWith("PGP"))
	return "manifest/signature-bin";
      if (string.endsWith("SF"))
	return "manifest/signature-asc";
      else
	return null;
    }

  public synchronized AudioClip getAudioClip(URL url)
    {
      AudioClip o=(AudioClip)audioHash.get(url);
      if(o==null)
	audioHash.put(url,o=new AppletAudioClip(url));
      return o;
    }

  public void flushAudioClips()
    {
      audioHash=new Hashtable();
    }

  Image getImage(URL url)
    {
      byte[] o=(byte[])getLocalResource(url);
      if(o!=null)
	return Toolkit.getDefaultToolkit().createImage(o);
      return Toolkit.getDefaultToolkit().createImage(new URLImageSource(url));
    }
  private void putLocalResource(URL url,byte ab[],String s)
    {
      resourceHash.put(url,ab);
      mimeHash.put(url,s);
    }
  public Object getLocalResource(URL u)
    {
      BufferedInputStream bis;
      Object o;
      String s=(String)mimeHash.get(u);
      if(s==null)
	return null;
      if(s.startsWith("audio") && (o=audioHash.get(u))!=null)
	return o;
      return resourceHash.get(u);
    }

  public InputStream getLocalResourceStream(URL url)
    {
      Object o=null;
      if((o=resourceHash.get(url))==null)
	return null;
      return new BufferedInputStream(new ByteArrayInputStream((byte[])o));
    }

  public String getResourceAsName(String s)
    {
      URL u0,u1;
      Object o0;
      u1=loader.getCodeBase();
      try
	{
	  u0=new URL(u1,s);
	  o0=resourceHash.get(u0);
	}
      catch(Exception e1)
	{
	  return null;
	}
      if(o0==null)
	return u0.toExternalForm();
      try
	{
	  u0=new URL("appletresource",u1.getHost(),u1.getPort(),u1.toExternalForm()+"/+/"+s);
	  return u0.toExternalForm();
	}
      catch(Exception e)
	{
	}
      return null;
    }

  public InputStream getResourceAsStream(String string)
    {
      URL uRL2;
      InputStream inputStream;
      URLConnection uRLConnection;
      URL uRL1 = loader.getCodeBase();
      try
        {
	  uRL2 = new URL(uRL1, string);
	  inputStream = getLocalResourceStream(uRL2);
        }
      catch (Exception e1)
        {
	  return null;
        }
      if (inputStream != null)
        {
	  return inputStream;
        }
      try
        {
	  uRLConnection = uRL2.openConnection();
        }
      catch (Exception e2)
        {
	  return null;
        }
      try
	{
	  if (uRLConnection instanceof HttpURLConnection)
	    {
	      HttpURLConnection httpURLConnection = (HttpURLConnection)uRLConnection;
	      int i = httpURLConnection.getResponseCode();
	      if (i == 200)
		inputStream = uRL2.openStream();
	      if (i >= 400)
		inputStream = null;
	    }
	  else
	    inputStream = uRL2.openStream();
	  return inputStream;
	}
      catch(Exception e)
	{
	  return null;
	}
    }

  void markLocalClass(URL url)
    {
      resourceHash.put(url,"A CLASS FILE");
      mimeHash.put(url,"application/java-vm");
    }
    
  
  void resetLocalResources()
    {
      resourceHash.clear();
    }

  
}
