package webwisdom.pure;

import java.awt.*;
import java.applet.*;
import java.awt.peer.*;
import java.net.*;
import java.io.*;
import webwisdom.tango.structures.*;
import java.awt.event.*;

public class Tango extends webwisdom.tango.interfaces.PureJavaInterface
{
  String root;
  static ThreadGroup mainthg;

  public String getRoot()
    {
      System.out.println("\nGetting root called:"+root+"\n");
      return root;
    }

  public static void main(String a[])
    {
      try
	{
	  Tango t=new Tango(a);
	  t.init();
	}
      catch(Exception e)
	{
	  String s=
	    "\nStandalone Tango Interactive\n"+
	    "\n"+
	    "Starts the Tango System\n"+
	    "\n"+
	    "Syntax:"+
	    "\tjava webwisdom.pure.Tango <server> <serverPort> <localPort> <caURL>\n"+
	    "where:\n"+
	    "\tserver     : hostname of the Tango central server\n"+
	    "\tserverPort : port used by the central server\n"+
	    "\tlocalPort  : port used for communication with local applications\n"+
	    "\tcaURL       : location of HTML file for the CA applet\n"+
	    "\n"+
	    "Standalone part written by Piotr Sokolowski\n"+
	    "(C) NPAC @ Syracuse University\n\n";
	    
	  System.out.println(s);
	  System.exit(1);
	}
    }

  public String getHost()
    {
      return host;
    }
  public int getServerPort()
    {
      return port;
    }
  public int getLocalPort()
    {
      return lport;
    }

  static String host;
  static int port;
  static int lport;
  String urls;
  
  public Tango(String a[]) throws Exception
    {  
      pji=this;
      mainthg=Thread.currentThread().getThreadGroup();
      Object o=System.getProperties().get("java.home");
      System.getProperties().put("java.home",".");
      System.out.println(Toolkit.getProperty("AWT.EventQueueClass",""));
      TangoToolkit.init();
      System.getProperties().put("java.home",o);

      host=(String)a[0];
      port=Integer.parseInt(a[1]);
      lport=Integer.parseInt(a[2]);
      urls=a[3];
      LocalBase lb=LocalBase.getLocalBase();
      
      System.out.println(LocalBase.getLocalBase());
      System.getProperties().put("LocalBase",LocalBase.getLocalBase());
      System.out.println("LocalBase2:"+System.getProperties().get("LocalBase"));
      Runtime.runFinalizersOnExit(true);
      System.setSecurityManager(new TangoSecurityManager());
      this.root=System.getProperty("tango_root");
      String logname=System.getProperty("log_name");
      if(logname!=null)
	{
	  PrintStream log=new PrintStream(new FileOutputStream(logname));
	  System.setOut(log);
	  System.setErr(log);
	}
    }
  
  public void init()
    {
      try
	{
	  String s0[]={urls,""};
	  AppletStarter ar=new AppletStarter(s0);
	  ar.getFrame().addWindowListener(new TangoKiller(mainthg));
	  
	}
      catch(Exception e)
	{
	  e.printStackTrace();
	}
    }

  public static void stop(ThreadGroup thg)
    {
      AppletKiller ak=new AppletKiller(thg);
      Thread th=new Thread(mainthg,ak);
      th.start();
    }

  public void startApplet(String s[])
    {
      new AppletStarter(s);
    }

  public void startScript(String url,int aid,int sid,int at)
  
    {
        System.out.println("Tango: startScript called");
        Runtime rt = Runtime.getRuntime();
        String command = generateCommandPage(url, aid, sid, at);
	      PrintStream starter;
	      FileOutputStream f;
	      Process p;
	      
	      try {
	
		       f=new FileOutputStream("starter.html");
			     starter = new PrintStream(f);
			     
			 	      
			      starter.print(command);
	      
			  	   System.out.println("Tango: before exec");
       
			      p = rt.exec("netscape file:\\starter.html");
			      
			      System.out.println("Tango: after exec" + p);
			      
			   } catch(Exception e) {
			  
			    e.printStackTrace();
			    starter = null;
			  }

	      
	      // run Netscape with file
    
    }
    

  public void startApplication(String path,int aid,int sid,int at)
    {
      try
	{
	  String longpath=getRoot()+path;
	  String cmdarray[]={longpath,""+aid,""+sid,""+at,""+lport,""};
	  Runtime.getRuntime().exec(cmdarray);
	}
      catch(Exception e)
	{
	  e.printStackTrace();
	}
    }
  public void quit()
    {
      System.out.println("QUIT CALLED");
      System.exit(0);
    }
    
  public String generateCommandPage(String path, int aid, int sid, int at) {
 
   
    String windowName = "win" + aid + "_" + sid + "_" + at;
    String result = new String    

     ("<html>" + '\n' +
	     "<head>" + '\n' +
		      "<title>Start page</title>" + '\n' +
	     "</head>" + '\n' +
	     
	     "<body>" + '\n' +
		      "<script>" + '\n' +
			       "window.name = \"Tango_Ca\";" + '\n' +
			       "window.open(\"" + path + "\",\"" + windowName + 
			       "\", \"toolbar=no, directories=no, menubar=no, scrollbars=no, resizable=no, width=300, height=300\");" 
			       + '\n' +       
		      "</script>" + '\n' +
	     "</body>" + '\n' +
      "</html>");

    System.out.println(result);
    
    return result;
 }


}

class TangoKiller extends WindowAdapter implements Runnable
{
  ThreadGroup thg;
  TangoKiller(ThreadGroup thg)
    {
      this.thg=thg;
    }
  public void windowClosed(WindowEvent we)
    {
      (new Thread(thg,this)).start();
    }
  public void run()
    {
      System.out.println("TANGO WINDOW CLOSED");
      try
	{
	  Thread.sleep(10000);
	}
      catch(Exception e)
	{
	}
      System.exit(0);
    }
}

class AppletKiller implements Runnable
{
  ThreadGroup thg;
  AppletKiller(ThreadGroup thg)
    {
      this.thg=thg;
    }
  public void run()
    {
      try
	{
	  Thread.sleep(30000);
	  System.out.println("KILLING THREADGROUP:"+thg);
	  thg.stop();
	  System.gc();
	}
      catch(Exception e)
	{
	  e.printStackTrace();
	}
    }
}

