package webwisdom.pure;

import java.applet.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.io.*;
import java.awt.event.*;


class TangoAppletPanel extends Panel
{
  int pw,ph;
  Component c;
  public TangoAppletPanel(int w,int h)
    {
      setLayout(null);
      pw=w;
      ph=h;
    }
  public Component add(Component c)
    {
      this.c=c;
      removeAll();
      return super.add(c);
    }
  public Dimension getPreferredSize()
    {
      return new Dimension(pw,ph);
    }
  public void doLayout()
    {
      if(c!=null)
	c.setBounds(0,0,getSize().width,getSize().height);
      super.doLayout();
    }
}



public class TangoAppletLoader extends Frame implements AppletStub,AppletContext
{
  Hashtable h=new Hashtable();
  boolean parsing=false;
  URL base;
  URL docbase;
  TClassLoader tcl;
  TResourceLoader trl;
  Applet applet;
  boolean noresize=false;
  AppletStarter as;

  static public void main(String s[])
    {
      try
	{
	  (	new TangoAppletLoader()).init(new URL(s[0]),null);
	}
      catch(Exception e)
	{
	  e.printStackTrace();
	}
      
    }

  public void processWindowEvent(WindowEvent we)
    {
      if(we.getID()==we.WINDOW_CLOSING)
	destroy();
      super.processWindowEvent(we);
    }
  public void destroy()
    {
      applet.stop();
      applet.destroy();
      as.quit();
    }

  public String toString()
    {
      if(as!=null)
	return as.s[1];
      else
	return super.toString();
    }

  public TangoAppletLoader()
    {
      super();
      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      //      hide();
      setVisible(false);
    }
  public String tos(Object o)
    {
      if(o!=null) return o.toString();
      else return null;
    }
  public void init(URL u,AppletStarter as) throws Exception
    {
      this.as=as;
      parseHtml(new BufferedReader(new InputStreamReader(u.openStream())));
      if(parsing==false)
	throw new Exception("Couldn't find applet tag");
      String codebase=tos(h.get("codebase"));
      String archive=tos(h.get("archive"));
      String name=tos(h.get("name"));
      String code=tos(h.get("code"));
      int width=100;
      int height=100;
      base=u;
      if(codebase!=null)
	{
	  if(!codebase.endsWith("/"))
	    codebase=codebase+"/";
	  base=new URL(u,codebase);
	}
      docbase=u;
      tcl=new TClassLoader(base);
      trl=tcl.getResourceLoader();
      if(archive!=null)
	trl.loadJar(base,archive);
      if(name==null)
	name="APPLET:"+h.get("code");
      width=Integer.parseInt(tos(h.get("width")));
      height=Integer.parseInt(tos(h.get("height")));
      setTitle(name);
      setLayout(new BorderLayout());
      if(code.endsWith(".class"))
	code=code.substring(0,code.length()-6);
      code=code.replace('/','.');
      java.lang.Class appletClass=tcl.loadClass(code);
      applet=(Applet)appletClass.newInstance();
      Panel p=new TangoAppletPanel(width,height);
      add("Center",p);
      doLayout();
      pack();
      applet.setStub(this);
      validate();
      p.add(applet);
      applet.doLayout();
      p.doLayout();
      invalidate();
      applet.init();
      applet.doLayout();
      applet.start();
      //      show();
      setVisible(true);
    }
  

  
  public void parseHtml(Reader r) throws Exception
    {
      String tag;
      while((tag=getTag(r))!=null)
	{
	  //System.out.println(tag);
	  if(parseTag(tag))
	    break;
	}
    }
  public String getTag(Reader r) throws Exception
    {
      boolean scanning=false;
      StringBuffer sb=new StringBuffer();
      int c;
      c=r.read();
      if(c<0)
	return null;
      do
	{
	  if(c<0)
	    return sb.toString().trim();
	  if(c=='<')
	    scanning=true;
	  else if(c=='>')
	    return sb.toString().trim();
	  else if(scanning)
	    sb.append((char)c);
	  c=r.read();
	}
      while(true);
    }
  
  public boolean parseTag(String tag) throws Exception
    {
      if(tag.toLowerCase().startsWith("applet") && !parsing)
	parseStartApplet(tag);
      if(tag.toLowerCase().startsWith("param") && parsing)
	parseParam(tag);
      if(tag.toLowerCase().startsWith("/applet") && parsing)
	return true;
      return false;
    }

  boolean equalsdetected=false;
  public String getAtom(Reader r) throws Exception
    {
      int quot=0;
      if(equalsdetected)
	{
	  equalsdetected=false;
	  return "=";
	}
      StringBuffer sb=new StringBuffer();
      int c=r.read();
      if(c<0)
	return null;
      while(c==' ' || c=='\t' || c=='\n')
	c=r.read();
      do
	{
	  if(c==quot)
	    {
	      quot=0;
	    }
	  else if(quot!=0)
	    {
	      sb.append((char)c);	
	    }
	  else if(c=='\'')
	    {
	      quot=c;
	    }
	  else if(c=='"')
	    {
	      quot=c;
	    }
	  else if(c==' ' || c=='\t' || c=='\n')
	    {
	      return sb.toString();
	    }
	  else if(c=='=')
	    {
	      equalsdetected=true;
	      return sb.toString();
	    }
	  else
	    sb.append((char)c);
	  c=r.read();
	  if(c<0)
	    return sb.toString();
	}
      while(true);
    }

  public String strip(String s) throws Exception
    {
      if(s==null) return null;
      String s0=s.trim();
      if(s0.startsWith("'"))
	{
	  s0=s0.substring(1,s0.length()-1);
	}
      if(s0.startsWith("\""))
	{
	  s0=s0.substring(1,s0.length()-1);
	}
      return s0.trim();
    }

  public void parseStartApplet(String tag) throws Exception
    {
      //System.out.println("parsestartapplet");
      parsing=true;
      StringReader sr=new StringReader(tag);
      String key=null;
      String value="";
      String temp="";
      while((temp=getAtom(sr))!=null)
	{
	  //System.out.println("TEMP:"+temp);
	  if(temp.equals("="))
	    {
	      value=getAtom(sr);
	      temp=getAtom(sr);
	    }
	  else
	    {
	      value="";
	    }
	  if(key!=null)
	    {
	      String k=strip(key);
	      String v=strip(value);
	      h.put(k,v);
	      h.put(k.toLowerCase(),v);
	    }
	  key=temp;
	}
    }
  public void parseParam(String tag) throws Exception
    {
      String pname="";
      String pvalue="";
      String temp;
      String key="";
      String value=null;
      StringReader sr=new StringReader(tag);
      
      while((temp=getAtom(sr))!=null)
	{
	  if(temp.equals("="))
	    {
	      value=getAtom(sr);
	      temp=getAtom(sr);
	    }
	  else
	    {
	      value="";
	    }
	  if(strip(key).equalsIgnoreCase("name"))
	    pname=strip(value);
	  if(strip(key).equalsIgnoreCase("value"))
	    pvalue=strip(value);
	  key=temp;
	}
      h.put(pname,pvalue);
      h.put(pname.toLowerCase(),pvalue);
    }


  public Applet getApplet(String s)
    {
      return null;
    }
  public Enumeration getApplets()
    {
      return (new Vector()).elements();
    }
  public java.applet.AudioClip getAudioClip(URL u)
    {
      return trl.getAudioClip(u);
    }
  public Image getImage(URL u)
    {
      return trl.getImage(u);
    }
  public void showDocument(URL u)
    {
    }
  public void showDocument(URL u,String target)
    {
    }
  public void showStatus(String s)
    {
    }
  public void appletResize(int w,int h)
    {
    }
  public AppletContext getAppletContext()
    {
      return this;
    }
  public URL getCodeBase()
    {
      return base;
    }
  public URL getDocumentBase()
    {
      return docbase;
    }
  public String getParameter(String s)
    {
      return (String)h.get(s);
    }
  public boolean isActive()
    {
      return true;
    }
}







