/****************************************************************************
  $Id: TControlListener.java,v 1.7 1998/10/13 18:18:32 toma Exp $
****************************************************************************/


package webwisdom.tango;


/**Interface for passing system level information to applications.
   The interface informs about the type of the change.
   The actual values of changed parameters can be checked
   with the application agent.
   *@see TAgent*/
public interface TControlListener
{


    /**This function is called everytime the session master
       of this session is changed.
       *@see TAgent#isMaster
       *@see TAgent#getMasterName*/
    public void masterChanged(boolean isMaster,String masterName);
    

    /**Called when a Tango user joins this session.
     *@see TAgent#getParticipantNames*/
    public void participantJoined(String name);
    
    
    /**Called when a participant of this session leaves this session.
     *@see TAgent#getParticipantNames*/
    public void participantLeft(String name);
    
    
    /**Called when audio device is requested or released by the system.
       If audio is requested this application should stop using audio
       until it is released again.
       *@see TAgent#isAudioAvailable*/
    public void audioRequested(boolean r);


}// TControlListener ////////////////////////////////////////////////////////

