/****************************************************************************
  $Id: TLAgentScript.java,v 1.4 1998/11/03 00:53:03 piotr Exp $
****************************************************************************/


package webwisdom.tango;


import java.util.Vector;

import webwisdom.tango.consts.CAConsts;
import webwisdom.tango.consts.Const;
import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.structures.AppletHandle;
import webwisdom.tango.structures.LocalBase;
import webwisdom.tango.interfaces.AppletBaseInterf;

import netscape.javascript.JSObject;


/**Tango system proxy for scripts.
   This class may be used to create TAgent.
   *@see TAgent*/
public final class TLAgentScript implements TLAgent,AppletBaseInterf
{
    private static final String CL="TLAgentScript";


    private JSObject script=null;
    private AppletHandle handle=null;
    private TLListener lowlList=null;


    /**Registers an script in the Tango system.
     *@param app script to be registered
     *@exception TangoException if cannot get reference to Tango*/
    public TLAgentScript(JSObject scr) throws TangoException
    {
      if(scr==null)
	throw new IllegalArgumentException("null script");
      script=scr;
      
      try
      {
	handle=TLAgentApplet.register(this);
      }
      catch(UnsatisfiedLinkError e)
      {
	throw new TangoException("Not in Netscape");	
      }
      catch(NoClassDefFoundError e)
      {
	throw new TangoException("Not in Netscape");	
      }
      if(handle==null)
	throw new TangoException("Tango demon not found");
    }// TLAgentScript ______________________________________________________


    public void exit()
    {
      //System.out.println(CL+".exit()");
      handle.remove();
      handle=null;
    }// exit _______________________________________________________________


    public void add(TLListener tl)
    {
      lowlList=tl;
    }// add ________________________________________________________________

  
    public final void send(AppEventMessage m)
    {
      handle.sendAppToOther(m);
    }// send _______________________________________________________________


    public void send(int userlist[],AppEventMessage m)
    {
      handle.sendAppToOther(userlist,m);
    }// send _______________________________________________________________


    public void receive(AppEventMessage m)
    {
      if(lowlList!=null)
	lowlList.receive(m);
    }// receive ____________________________________________________________


    public Object getJSWindow()
    {
      try {
       
//		    JSObject window = (JSObject)((JSObject)script.getWindow(scr));
         
    
	      JSObject parent=(JSObject)script.getMember("top");  		 	
	      String winName=(String)parent.getMember("name");
	      JSObject targetWindow;
	
	      System.out.println(CL + ": top window name " + winName);
	
	      if (winName.equals("TangoCa")) {

		      System.out.println(CL + ": applet running in frame");
 
		      targetWindow = script;
        
	      } else {
    
		      System.out.println(CL + ": applet running in window");
		      targetWindow = parent;
	      }
  
        return targetWindow;  
      
       } catch(Exception e) {
       
		     return null;
	     }

      
    }// getJSWindow ________________________________________________________


    public String toString()
    {
      return CL+"[script="+script+",handle="+handle+"]";
    }// toString ___________________________________________________________


}// TLAgentScript //////////////////////////////////////////////////////////

  
