/****************************************************************************
  $Id: TangoClient.java,v 1.4 1998/07/22 17:17:27 toma Exp $
****************************************************************************/


package webwisdom.tango;


/**Java interface for Tango applications.
   TangoClient should create its own TangoAgent
   as an intermediary with the Tango system.
 *@author Tomasz Major
 *@see TangoAgent*/
public interface TangoClient
{


    /**Receives data from the same session.
       Should be implemented in order to get any usueful collaboration.
       *@param bytes exchanged data*/
    public void receive(byte[] bytes);
    // receive _____________________________________________________________


    /**Receives data from different sessions. Should be implemented
       if application expects exchange with applications of different types.
       *@param sess application originating exchange
       *@param bytes exchanged data*/
    public void crossReceive(String sess,byte[] bytes);
    // crossReceive ________________________________________________________


    /**Receives control data from the Tango system.
       *@param message content of control message*/
    public void controlReceive(TangoMsg message);
    // controlReceive ______________________________________________________


}// TangoClient ////////////////////////////////////////////////////////////


