/****************************************************************************
  $Id: TangoMsg.java,v 1.1 1998/07/21 18:53:48 toma Exp $
****************************************************************************/


package webwisdom.tango;


/**Generic control message sent from TangoAgent to TangoClient.<br>
   TangoMessage should be casted to the appropriate subtype
   of control message according to the message type.
   *@see TangoClient#controlReceive()*/
public abstract class TangoMsg
{
    private static final String CL="TangoMsg";


    public static final int UNDEFINED=-1; //Const

    public static final int SYSTEM=0; //new type
    public static final int MASTER=1; //isMaster, masterName
    public static final int PARTICIPANTS=2; //CAConst
    public static final int USERS=3;
    public static final int SESSIONS=4;


    protected int type=UNDEFINED;


    /**Each control message has type which determines
     *@return type of the message
     *@see Const*/
    public int getType()
    {
      return type;
    }// getType ____________________________________________________________


    public static String typeToString(int t)
    {
      switch(t)
      {
	case MASTER:
	  return "MASTER";
	case PARTICIPANTS:
	  return "PARTICIPANTS";
	case USERS:
	  return "USERS";
	case SESSIONS:
	  return "SESSIONS";
	case SYSTEM:
	  return "SYSTEM";
	default:
	  return "UNDEFINED";
      }
    }// typeToString _______________________________________________________


    public String toString()
    {
      return CL+"["+typeToString(type)+"]";
    }// toString ___________________________________________________________


}// TangoMsg ///////////////////////////////////////////////////////////////


