// $Id: Const.java,v 1.6 1998/11/03 00:53:03 piotr Exp $
/*
File: ComThread.java
Component: Server, Plugin
Date		Author		Changes
Aug 22 96	Lukasz Beca	Created
*/


package webwisdom.tango.consts;

 
public class Const
{


    public static final int COMMAND = 1;
    public static final int FINISH  = 2; 
    public static final int EVENT   = 3;
    public static final int RJOIN   = 4;
    public static final int RASK    = 5;
    public static final int RANS    = 6;
    public static final int SUPD    = 7;
    public static final int MASTER  = 8;
    public static final int MASK    = 9;
    public static final int MANS    = 10;
    public static final int LOGIN   = 11;
    public static final int LOGACC  = 12;
    public static final int LOGOUT  = 13;
    public static final int JOIN    = 14;
    public static final int JASK    = 15;
    public static final int JANS    = 16;
 

    public static final int UNDEFINED = -1;
 
    public static final int ADDUPDATE = 23;
    public static final int REMOVEUPDATE = 24;
    public static final int MASTERUPDATE = 25;
    public static final int LOGINUPDATE = 26;
    public static final int LOGOUTUPDATE = 27;

    public static final int YES = 28;
    public static final int NO  = 29;
    
    public static final int CONTROL = 30;
    public static final int DATA = 31;
    
    //error constants start
    
    public static final int FILEWRONGFORMAT = 34;
    public static final int UNABLETOLISTEN = 35;
    public static final int UNABLETOCONNECT = 36;
    public static final int CONNBROKEN = 43;
    
    //error constants end
    
    public static final int CACLOSED = 37;
    public static final int WINDOWCLOSED = 38;
    public static final int NONE = 39;
    
    public static final int TERMINATEDEND = 40;
    public static final int LOGOUTEND = 41;
    public static final int CONNECTIONEND = 42;
    
    
    public static final int STARTED = 44;
    
    public static final int GROUP_EVENT = 50;
    public static final int PING = 51;
    
    public static final byte OK = 52;
    public static final byte TESTING = 49;
    
    public static final int CRLAID = -7;
    
    public static final byte UNUSED=-127;
    
    
    /**
     *@param t const type
     *@return const name*/
    public static String toString(int t)
    {
      switch(t)
      {
	case COMMAND:
	  return "COMMAND";
	case FINISH:
	  return "FINISH";
	case EVENT:
	  return "EVENT";
	case RJOIN:
	  return "RJOIN";
	case RASK:
	  return "RASK";
	case RANS:
	  return "RANS";
	case SUPD:
	  return "SUPD";
	case MASTER:
	  return "MASTER";
	case MASK:
	  return "MASK";
	case MANS:
	  return "MANS";
	case LOGIN:
	  return "LOGIN";
	case LOGACC:
	  return "LOGACC";
	case LOGOUT:
	  return "LOGOUT";
	case JOIN:
	  return "JOIN";
	case JASK:
	  return "JASK";
	case JANS:
	  return "JANS";
	case UNDEFINED:
	  return "UNDEFINED";
	case ADDUPDATE:
	  return "ADDUPDATE";
	case REMOVEUPDATE:
	  return "REMOVEUPDATE";
	case MASTERUPDATE:
	  return "MASTERUPDATE";
	case LOGINUPDATE:
	  return "LOGINUPDATE";
	case LOGOUTUPDATE:
	  return "LOGOUTUPDATE";
	case YES:
	  return "YES";
	case NO:
	  return "NO";
	case CONTROL:
	  return "CONTROL";
	case DATA:
	  return "DATA";
	case FILEWRONGFORMAT:
	  return "FILEWRONGFORMAT";
	case UNABLETOLISTEN:
	  return "UNABLETOLISTEN";
	case CONNBROKEN:
	  return "CONNBROKEN";
	case CACLOSED:
	  return "CACLOSED";
	case WINDOWCLOSED:
	  return "WINDOWCLOSED";
	case NONE:
	  return "NONE";
	case TERMINATEDEND:
	  return "TERMINATEDEND";
	case LOGOUTEND:
	  return "LOGOUTEND";
	case CONNECTIONEND:
	  return "CONNECTIONEND";
	case STARTED:
	  return "STARTED";
	case GROUP_EVENT:
	  return "GROUP_EVENT";
	case PING:
	  return "PING";
	case OK:
	  return "OK";
	case TESTING:
	  return "TESTING";
	case CRLAID:
	  return "CRLAID";
	default:
	  return "UNDEFINED_CONST";
      }
    }// toString ___________________________________________________________

  public static boolean inNetscape()
    {
      String browser=System.getProperty("java.vendor").toLowerCase();
      boolean b=(browser.indexOf("netscape")>=0);
      System.out.println("BROWSER"+browser+":"+b);
      return b;
    }
}// Const //////////////////////////////////////////////////////////////////


