/****************************************************************************
  $Id: FakeTangoClient.java,v 1.3 1998/07/20 20:40:16 toma Exp $
  PURPOSE: easy testing of Tango applets
****************************************************************************/


package webwisdom.tango.fake;


import webwisdom.tango.*;
import webwisdom.tango.interfaces.*;

import java.io.*;


/**This class exists only for testing of FakeTango testbed.
 *@see FakeTangoAgent
 *@author Tomasz Major*/
public class FakeTangoClient extends Thread implements TangoClient
{
    private static final String CL="FakeTangoClient";


    private String serverHost;
    private int serverPort;


    public FakeTangoClient(String h,int p)
    {
      serverHost=h;
      serverPort=p;
    }// FakeTangoClient ____________________________________________________


    public void run()
    {
      try
      {
	FakeTangoAgent agent=new FakeTangoAgent(this,serverHost,serverPort);
	DataInputStream kbdInStream=new DataInputStream(System.in);
	do
	{
	  System.out.print(CL+".> ");
	  System.out.flush();
	  String line=kbdInStream.readLine();
	  int packetLen=line.length();
	  byte[] packetData=new byte[packetLen];
	  line.getBytes(0,packetLen,packetData,0);
	  
	  agent.send(packetData);
	}
	while(true);
      }
      catch(Exception e)
      {
	System.err.println(CL+".exception: "+e);
      }
    }// run ________________________________________________________________


    public void receive(byte[] b)
    {
      String line=new String(b,0);
      System.out.println(CL+".< "+line);
    }// receive ____________________________________________________________


    public void crossReceive(String app,byte[] b)
    {
    }// receive ____________________________________________________________


    public void controlReceive(TangoMsg m)
    {
    }// receive ____________________________________________________________


    public String toString()
    {
	return CL+"[]";
    }// toString ___________________________________________________________


    public static void main(String[] args)
    {
      FakeTangoClient client;
      try
      {
	String host=args[0];
	int port=Integer.valueOf(args[1]).intValue();
	client=new FakeTangoClient(host,port);
	//client.setPriority(Thread.MIN_PRIORITY);
	client.start();
      }
      catch(Exception e)
      {
	System.err.println(CL+".exception: "+e);
      }
    }// main _______________________________________________________________


}// FakeTangoClient ////////////////////////////////////////////////////////


