// $Id: ControlAppletBase.java,v 1.9 1998/11/03 00:53:04 piotr Exp $
/*
File: ControlAppThreadIn.java
Component: Plugin
Date		Author		Changes
Sep 09 96	Lukasz Beca	Created
14May98         TomaszMajor     plugin on the same page, AppletBase register
*/


package webwisdom.tango.interfaces;


import java.applet.Applet;
import webwisdom.tango.messages.Message;
import webwisdom.tango.structures.LocalBase;
import webwisdom.tango.structures.ControlApplication;
//import netscape.javascript.JSObject;
import webwisdom.tango.consts.Const;


public abstract class ControlAppletBase extends Applet implements ControlAppletBaseInterf
{
    private static final String CL="ControlAppletBase";


    private ControlApplication ca=null;
  

    public int register()
    {
      //System.out.println(CL+".register()");
      LocalBase localBase=LocalBase.getOtherLocalBase();
      if(localBase==null)
      {
	System.err.println(CL+".register(): plugin not found!");
	destroy();
	return Const.OK;
      }
      ca=localBase.reg.registerCA(this);
      if(ca==null)
	throw new Error("null ca");
      //System.out.println(CL+".register(): ok");
      return ca.getStatus();    
    }// register ___________________________________________________________


    public void sendServer(Message m)
    {    
      ca.sendCABToCS(m);
    }


    public void sendApp(int AID,Message m)
    {
      ca.sendCABToApp(AID,m);
    }


    public void finish(int AID)
    {
      ca.finish(AID);  
    }


    public void logout()
    {
      ca.logout();
    }

  
    public String getServer()
    {
      return ca.getServerHost();
    }


    public boolean appExists(int AID)
    {
      return ca.appExists(AID);
    }
    

    public void startApplet(String url,int AID,int SID,int AT,
			    String height,String width)
    {
      ca.startApplet(url,AID,SID,AT,height,width); 
    }// startApplet ________________________________________________________


    public void startAppletInFrame(String url,int AID,int SID,int AT, String frameName)
    {
      ca.startAppletInFrame(url,AID,SID,AT, frameName); 
    }// startAppletInFrame _________________________________________________


    public void startApplication(int AID, int SID, int AT)
    {
      String path=getApplicationPath(AT);
      ca.startApplication(path,AID,SID,AT);
    }// startApplication ___________________________________________________


    public synchronized abstract void receiveServer(Message m);


    public synchronized abstract void receiveApp(int AID,Message m);
  

    public synchronized abstract void addApplication(int AID,int SID,int AT);
  

    public abstract String getApplicationPath(int AT);


    public abstract void removeApplication(int AID);


    public synchronized abstract void error(int errorCode);
    
    public abstract String getDefaultContent(String frameName);
    

    public void setFocus(int AID)
    {
      ca.setFocus(AID);   
    }


    public Object getJSWindow()
    {
      if(Const.inNetscape())
	{
	  return netscape.javascript.JSObject.getWindow(this);
	}
      else
	{
	  return null;
	}
    }// getJSWindow ________________________________________________________


    public String toString()
    {
      return CL;
    }// toString ___________________________________________________________


}// ControlAppletBase //////////////////////////////////////////////////////

