// $Id: AppMessage.java,v 1.4 1998/07/10 20:15:19 beca Exp $
//
// File:        AppMessage.java
// Component:   Plugin
// Author:      Lukasz Beca
// e-mail:      <beca@>
// Created:     Mon Apr 14 1997
// Time-stamp: <97/04/15 11:53:11 beca>
// Copyright Lukasz Beca 1997 NPAC, Syracuse University
// Description:
//


package webwisdom.tango.messages;


import java.io.*;
import webwisdom.tango.consts.Const;


/**
* Base class for other message classes
*
* @version	1.0 22 Aug 1995
* @author 	Lukasz Beca
*
**/
public abstract class AppMessage
{


    /**type of message*/
    protected int type;


/**
* Creates undefined message
**/


  AppMessage () {

	type = Const.UNDEFINED;

  }

  /**
   * Returns type of the message represented by this object
   * @return type of the message
   * @see Const
   **/
 
  public int getType() {

   return type;
  }

  /**
   * Abstract method sending message 
   * @param outstream message is put to outstream stream
   **/
 
  abstract void send(DataOutputStream outstream) throws IOException;


}// AppMessage /////////////////////////////////////////////////////////////


