// $Id: CAppAnswerEventMessage.java,v 1.4 1998/07/10 20:15:20 beca Exp $
//File:    CAppAnswerEventMessage.java
//Component: Plugin
//Author:  Tomasz Jurga	
//Descr:   data for Control Application-applets protocol. More details: http://trurl.npac.syr.edu/~toju/Protocol.txt
//Date:    11/21/96
//Changes: no


package webwisdom.tango.messages;

import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.consts.*;
import java.util.Vector;
import java.io.*;


public class CAppAnswerEventMessage extends AppEventMessage
{
    private static final String CL="CAppAnswerEventMessage";


  public CAppAnswerEventMessage(byte[] tab)
  {
    super(Const.CONTROL, tab);
  } 


  public byte getAnswerType()
  {
    return (super.getData())[0];
  }


  public boolean isMaster()
  {
    if ((super.getData())[0]==CAConsts.ISMASTER)
    {
      byte[] data = super.getData();
      boolean res = false;

      if (data[1] == CAConsts.YES) res=true; 
 
      return res;
    }
    else return false;
  }


  public String getMastername()
  {
    if ((super.getData())[0]==CAConsts.MASTERNAME)
    {
      byte[] data = super.getData();
      int len = super.getLen();

      return new String(data,0,1,len-1);
    }
    else return null;
  
  }

  public String getUsername()
  {
    if ((super.getData())[0]==CAConsts.USERNAME)
    {
      byte[] data = super.getData();
      int len = super.getLen();

      return new String(data,0,1,len-1);
    }
    else return null;
  
  }

  public String getHostname()
  {
    if ((super.getData())[0]==CAConsts.HOSTNAME)
    {
      byte[] data = super.getData();
      int len = super.getLen();

      return new String(data,0,1,len-1);
    }
    else return null;
  }

  public String getSender()
  {
    if ((super.getData())[0]==CAConsts.DATAPASS)
    {
      ByteArrayOutputStream appname = new ByteArrayOutputStream();
      byte[] data = super.getData();
      int len = super.getLen();
      int appname_len = data[1];
      appname.write(data,2,appname_len);
    
      return new String(appname.toByteArray(),0);
    }
    else return null;
  }

  public byte[] getData()
  {
    if ((super.getData())[0]==CAConsts.DATAPASS)
    {
      ByteArrayOutputStream datapass = new ByteArrayOutputStream();
      byte[] data = super.getData();
      int len = super.getLen();
      int appname_len = data[1];
      datapass.write(data,appname_len+2,len-appname_len-2);

      return datapass.toByteArray();
    }
    else 
    {
      try {
      byte[] tmp = super.getData();
      byte[] res = new byte[tmp.length-1];
      System.arraycopy(tmp,1,res,0,tmp.length-1);
      return res;
      } 
      catch (Exception ex) {ex.printStackTrace();}
      return null;
    }
  }


  Vector processData()
  {
    int len = super.getLen();
    byte[] data = super.getData();

    int index=1;
    Vector vect = new Vector();

    while (index<len)
    {
      int strlen = (int) data[index];
      index++;
      String pom = new String(data,0,index,strlen);
      vect.addElement(pom);
      index+=strlen; 
    }
      
    return vect;
  }


  public Vector getParticipants()
  {
    if ((super.getData())[0]==CAConsts.PARTICIPANTS)
    {
      return processData();
    }
    else return null;  
  }


  public Vector getActiveUsers()
  {
    if ((super.getData())[0]==CAConsts.ACTIVEUSERS)
    {
      return processData();
    }
    else return null;
  }


  public Vector getLocalApps()
  {
    if ((super.getData())[0]==CAConsts.LOCALAPPS)
    {
      return processData();
    }
    else return null;  
  }
    public String toString()
    {
      return CL+"[]";
    }// toString __________________________________________________________


}// CAppAnswerEventMessage ////////////////////////////////////////////////


