// $Id: MaskMessage.java,v 1.4 1998/07/10 20:15:32 beca Exp $
/*
File: MaskMessage.java
Component: Server, Plugin
Date		Author		Changes
Aug 22 96	Lukasz Beca	Created
*/


package webwisdom.tango.messages;


import java.io.*;
import webwisdom.tango.consts.Const;
import webwisdom.tango.messages.Message;


/**
 * A class representing MASK message
 * 
 *@author Lukasz Beca
 *@see Central Server - Local Demon protocol
 **/
public class MaskMessage extends Message
{
    private static final String CL="MaskMessage";


    private int UID;
    private int SID;


 /**
   * Creates a new MASK message
   *@param SIDpar session number
   *@param UIDpar user number
   **/

  public MaskMessage(int SIDpar, int UIDpar) {

   SID = SIDpar;
   UID = UIDpar;
  
   type = Const.MASK;
  }

 /**
   * Creates a new MASK message, information is read from the input stream
   *@param instream  input stream
   **/

  MaskMessage(DataInputStream instream) throws IOException {
    
  
    SID= instream.readInt();     
    UID = instream.readInt();
       
    type = Const.MASK;
    
  }

 /**
   * Writes MASK message to the output stream
   *@param outstream  output stream
   **/


  void send(DataOutputStream outstream) throws IOException {
  
      //System.out.println("Sending type " + Const.MASK);
      outstream.writeInt(Const.MASK);
      //System.out.println("Sending SID " + SID);
      outstream.writeInt(SID);
      //System.out.println("Sending UID " + UID);
      outstream.writeInt(UID);
     
      outstream.flush();

  }
  
 /**
   * Returns user number
   **/

  public int getUID() {
       
    return UID;

  }  

  /**
   * Returns session number
   **/  

  public int getSID() {
   
    return SID;
  }

 
  
    public String toString()
    {
      return CL+"[UID="+UID+",SID="+SID+"]";
    }// toString __________________________________________________________


}// MaskMessage ///////////////////////////////////////////////////////////


