// $Id: StartedMessage.java,v 1.4 1998/07/10 20:15:38 beca Exp $

/*
File: StartedMessage.java
Component: Server, Plugin
Date		Author		Changes
Apr 15 97	Lukasz Beca	Created
*/


package webwisdom.tango.messages;


import webwisdom.tango.messages.Message;
import webwisdom.tango.consts.Const;
import java.io.*;


/**
 * A class representing STARTED message
 * 
 *@author Lukasz Beca
 *@see Central Server - Local Demon protocol
 **/
public class StartedMessage extends Message
{
    private static final String CL="StartedMessage";


    private int AID;
    private int SID;


  /**
   * Creates a new STARTED message
   *@param AIDparam application number
   **/
  
  public StartedMessage(int AIDparam, int SIDparam) {
    
    AID = AIDparam;
    SID = SIDparam;
    type = Const.STARTED;
  }

  /**
   * Creates a new FINISH message, information is read from the input stream
   *@param instream  input stream
   **/


  StartedMessage(DataInputStream instream) throws IOException {
    
    
    AID = instream.readInt();     
    SID = instream.readInt();
    
    type = Const.STARTED;
    
  }

   /**
   * Writes FINISH message to the output stream
   *@param outstream  output stream
   **/

  void send(DataOutputStream outstream)  throws IOException{
  
    
    //System.out.println("Sending type " + Const.FINISH);
    outstream.writeInt(Const.STARTED);
    //System.out.println("Sending AID " + AID);
    outstream.writeInt(AID); 
    outstream.writeInt(SID);    
    outstream.flush();
  
  }
  
   /**
   * Returns application number
   **/
  public int getAID() {
       
    return AID;

  }   
  
  public int getSID() {
  
    return SID;
  }

    public String toString()
    {
      return CL+"[AID="+AID+",SID="+SID+"]";
    }// toString __________________________________________________________


}// StartedMessage ////////////////////////////////////////////////////////


