// $Id: TangoMetaAgent.java,v 1.4 1998/07/10 20:15:40 beca Exp $
/****************************************************************************
  FILE: TangoMetaAgent.java, TomaszMajor-11May98, mc-v0.00-12Feb97
  Component: Server
  PURPOSE: finding Tango servers
****************************************************************************/


package webwisdom.tango.meta;


import java.net.*;
import java.io.*;

// import tm.std.*;
import java.awt.*;
// import tm.awt.*;


class Receiver extends Thread
{
    private static final String CL="Receiver";
    private static final String CL2="TangoMetaAgent";


    DataInputStream inStream;
    TangoMetaClient client;


    public Receiver(DataInputStream is,TangoMetaClient tc)
    {
      inStream=is;
      client=tc;
    }// Receiver ___________________________________________________________


    public String toString()
    {
	return CL+"[]";
    }// toString ___________________________________________________________


    public void run()
    {
      try
      {
	do
	{
	  int packetLen=inStream.readInt();
	  byte[] packetData=new byte[packetLen];
	  inStream.readFully(packetData);
	  //client.receive(packetData);
	  //System.out.println(CL+".< "+new String(packetData,0));
	}
	while(true);
      }
      catch(EOFException e)
      {
	System.err.println(CL2+"."+CL+": Server disconnected!");
      }
      catch(IOException e)
      {
	System.err.println(CL2+"."+CL+": "+e);
      }
    }// run ________________________________________________________________


}// Receiver ///////////////////////////////////////////////////////////////




/**This class can be used instead of TangoAgent
   for browserless testing of Tango applets with TangoMetaServer.
   *@see TangoMetaServer
   *@author Tomasz Major*/
public class TangoMetaAgent
{
    private static final String CL="TangoMetaAgent";

    
    private Socket socket;
    private DataOutputStream outStream;
    private DataInputStream inStream;

    private Receiver receiverThread;

    private TangoMetaClient client;


    /**Creates TangoAgent which connects to TangoMetaServer.
     *@param cl client for which this agent is created
     *@param serverHost,serverPort fake tango server
     *@exception Exception if cannot connect to the server*/
    public TangoMetaAgent(TangoMetaClient cl,
			  String serverHost,int serverPort)
      throws IOException
    {
      if(cl==null)
	throw new Error("null client");
      client=cl;

      try
      {
	socket=new Socket(serverHost,serverPort);
	outStream=new DataOutputStream(socket.getOutputStream());
	inStream=new DataInputStream(socket.getInputStream());
	System.out.println(CL+".Connected to: "+socket);
      }
      catch(IOException e)
      {
	throw new IOException("cannot connect to "+serverHost+":"+serverPort);
      }

      receiverThread=new Receiver(inStream,client);
      //receiverThread.setPriority(Thread.MIN_PRIORITY);
      receiverThread.start();
      (Thread.currentThread()).setPriority(Thread.MIN_PRIORITY);
    }// TangoMetaAgent _____________________________________________________


    public void exit()
    {
      receiverThread.stop();
      try
      {
	inStream.close();
	outStream.close();
      }
      catch(IOException e)
      {
      }
    }// exit _______________________________________________________________


    public void send(byte[] b)
    {
      try
      {
	outStream.writeInt(b.length);
	outStream.write(b);
	outStream.flush();
	//System.out.println(CL+".send(byte["+b.length+"])");
      }
      catch(IOException e)
      {
	System.err.println(CL+".send(): "+e);
      }
    }// send _______________________________________________________________


    public String toString()
    {
      String host=socket.getInetAddress().getHostName();
      int port=socket.getPort();
      return CL+"["+host+":"+port+"]";
    }// toString ___________________________________________________________


}// TangoMetaAgent /////////////////////////////////////////////////////////


