// $Id: TangoMetaServer.java,v 1.4 1998/07/10 20:15:41 beca Exp $
/****************************************************************************
  FILE: TangoMetaServer.java, TomaszMajor-11May98, mc-v0.00-12Feb97
  Component: Server
  PURPOSE: finding Tango servers
****************************************************************************/


package webwisdom.tango.meta;


import java.net.*;
import java.io.*;
import java.util.Vector;

// import tm.std.*;
import java.awt.*;
// import tm.awt.*;


/**Server collecting information about TangoServers.
   Run with parameter being a port number.
   *@see TangoMetaAgent
   *@author Tomasz Major*/
public class TangoMetaServer
{
    private static final String CL="TangoMetaServer";
    private static final String CL2="TMS";


    ServerSocket server;


    /**Anchors at the given port.
     *@param port port at which the server is to listen for clients
     *@exception IOException if cannot start service at given port*/
    public TangoMetaServer(int port) throws IOException
    {
      server=new ServerSocket(port);
      port=server.getLocalPort();
      System.out.println(CL2+": listening on port: "+port);
    }// TangoMetaServer ____________________________________________________


    /**Starts the server.
       Servers accepts connections from clients
       and creates new thread for each client.
       *@exception IOException not caught system exceptions*/
    public void run() throws IOException
    {
      do
      {
	Socket socket=server.accept();
	System.out.println(CL2+": registering: "+socketToString(socket));
	socket.close();
      }
      while(true);
    }// run ________________________________________________________________


    public String toString()
    {
	return CL+"[]";
    }// toString ___________________________________________________________


    public static String socketToString(Socket s)
    {
      return "["+s.getInetAddress().getHostName()+":"+s.getPort()+"]";
    }// socketToString _____________________________________________________


    /**Creates and starts the server at the port given the first parameter.*/
    public static void main(String[] args)
    {
      int port=-1;
      try
      {
	port=Integer.valueOf(args[0]).intValue();
      }
      catch(NumberFormatException e)
      {
	System.err.println(CL+".main(): Usage: main(port)");
	System.exit(2);
      }

      TangoMetaServer s=null;
      try
      {
	s=new TangoMetaServer(port);
      }
      catch(IOException e)
      {
	System.err.println(CL+".main(): Cannot start server at port "+port+": "+e);
	System.exit(1);
      }

      try
      {
	s.run();
      }
      catch(IOException e)
      {
	System.err.println(CL+".main(): I/O error: "+e);
	System.exit(1);
      }
    }// main _______________________________________________________________


}// TangoMetaServer ////////////////////////////////////////////////////////


