package webwisdom.tango.object;

/**
  * Event that is passed to the AlarmListener when the alarm expires.
  * 
  * @author Piotr Sokolowski
  * @version $Revision: 1.2 $
  * @see webwisdom.tango.object.AlarmListener
  * @see webwisdom.tango.object.Alarm
  */
public class AlarmEvent
{
  /**
    * convenient code to identify the alarm.
    */
  public int code;
  
  /**
    * convenient object which may be passed when alarm fires.
    */
  public Object o;

  /**
    * constructor without code and without an object
    */
  public AlarmEvent()
    {
      code=-1;
      o=null;
    }

  /**
    * constructor with the code only
    */
  public AlarmEvent(int n)
    {
      code=n;
      o=null;
    }

  /**
    * constructor with the object only
    */
  public AlarmEvent(Object o)
    {
      this.o=o;
      code=-1;
    }

  /**
    * constructor using both the object and the code
    */
  public AlarmEvent(Object o,int n)
    {
      code=n;
      this.o=o;
    }

  public String toString()
    {
      return "[AlarmEvent:"+code+"]";
    }
}
