// $Id: Applications.java,v 1.3 1998/07/10 20:15:48 beca Exp $
/*
File: Applications.java
Component: Server
Date		Author		Changes
Aug 22 96	Lukasz Beca	Created

Tested:
OK

Notes:
fields must be changed to private	

*/

package webwisdom.tango.structures;

import java.util.*;


public class Applications {

  public Vector AIDVector;
  public Vector SIDVector; // public only for test purposes, must be changed
  public Vector UIDVector;
  public Vector Enabled;

  public Applications () {
    AIDVector = new Vector();
    SIDVector = new Vector();
    UIDVector = new Vector();
    Enabled = new Vector();
  }

 public void addApplication(int AIDpar, int SIDpar, int UIDpar) {

    Integer a = new Integer(AIDpar);
    Integer b = new Integer(SIDpar);
    Integer c = new Integer(UIDpar);
    Boolean d = Boolean.FALSE;
    int index;

    index = AIDVector.indexOf(a);

    if (index == -1) {
    
      AIDVector.addElement(a);
      SIDVector.addElement(b);
      UIDVector.addElement(c);
      Enabled.addElement(d);
    }
    else {
      System.out.println("Applications: application " + AIDpar + " already exists, cannot add");
    }

  }

  public Vector getApplications(int UID) {    //returns vector of AIDs of application
                                                  //run by user identified by UID
    
    Vector result = new Vector();

    Integer UIDpar = new Integer(UID);

    int index = 0;
    int start = 0;


    while(index != -1) {

      index = UIDVector.indexOf(UIDpar, start);
      start = index + 1;
      if (index != -1) result.addElement(AIDVector.elementAt(index));
    
    
    }
    if (result.size() == 0) 
      System.out.println("Applications: user " + UID + " does not run any application");
    return result;

  }


  public int getSession(int AID) {

     Integer tmp = new Integer(AID);
     int index;
     Integer tmpSID;
     int result;

     index = AIDVector.indexOf(tmp);
    
     if (index != -1) {

       tmpSID = (Integer) SIDVector.elementAt(index);

       result = tmpSID.intValue();
     }
     else {
      
       System.out.println("Applications: application " + AID + " does not exist");
       result = -1;

     }

     return result;
    


   }

  public boolean removeApplication(int AIDpar) {

    int index;
    Integer AID = new Integer(AIDpar);
    boolean result = false;
    Integer SIDtmp;
    Integer tmp;

    index = AIDVector.indexOf(AID);
    
    if (index != -1) {
      AIDVector.removeElementAt(index);
      UIDVector.removeElementAt(index);
      Enabled.removeElementAt(index);
      tmp = (Integer) SIDVector.elementAt(index); 
      SIDtmp = new Integer(tmp.intValue());
      SIDVector.removeElementAt(index);
      index = SIDVector.indexOf(SIDtmp);

      if (index == -1)
	result = true;
    }
    else {
       System.out.println("Applications: application " + AID + " does not exist");
       result = false;
    }

    return result;
    

  }

  public void removeFromSession(int SID) {
  
    Integer SIDpar = new Integer(SID);

    int index = 0;
    int start = 0;


    while(index != -1) {

      index = SIDVector.indexOf(SIDpar, start);
      start = index;
      if (index != -1) {
	SIDVector.removeElementAt(index);
	AIDVector.removeElementAt(index);
	UIDVector.removeElementAt(index);
	Enabled.removeElementAt(index);
      }
    
    }

  }

  public boolean inSession(int SIDpar, int UIDpar) {
    
    Integer tmpSID = new Integer(SIDpar);
    Integer tmpUID;
    int index;
    int start = 0;
    boolean found = false;



    do {
      
      index = SIDVector.indexOf(tmpSID, start);

      if (index != -1) {

	start = index + 1;
	tmpUID = (Integer) UIDVector.elementAt(index);
	found = (tmpUID.intValue() == UIDpar);
	  }

    }
    while(index != -1 && !found);


    return found;
    
	
  }
  
  public int getAID(int SIDpar, int UIDpar) {
    
    Integer tmpSID = new Integer(SIDpar);
    Integer tmpUID;
    int index;
    int start = 0;
    boolean found = false;
    int AID = 0;



    do {
      
      index = SIDVector.indexOf(tmpSID, start);

      if (index != -1) {

	      start = index + 1;
	      tmpUID = (Integer) UIDVector.elementAt(index);
	      found = (tmpUID.intValue() == UIDpar);
	
	      if (found) {
	      
		      AID = ((Integer) AIDVector.elementAt(index)).intValue();
				
	      }	
      }
    } while(index != -1 && !found);


    return AID;
    
	
  }

  

  public int getSize() {

    return AIDVector.size();

  }


  public int getSID(int index) {

    Integer tmp;

    try {
      tmp = (Integer) SIDVector.elementAt(index);
    } catch(Exception e) {
      
      System.out.println("Applications: err " + e);
      e.printStackTrace();
      tmp = new Integer(0);
    }
    
    return tmp.intValue();
  
  }  

    public int getUID(int index) {

    Integer tmp;

    try { 
      tmp = (Integer) UIDVector.elementAt(index);
     } catch(Exception e) {
      
      System.out.println("Applications: err " + e);
      e.printStackTrace();
      tmp = new Integer(0);
    }

    return tmp.intValue();
  
  }  


  public int getUser(int AID) {
  
    Integer tmp = new Integer(AID);
    int index;
    Integer tmpUID;


    index = AIDVector.indexOf(tmp);

    if (index != -1) {

    tmpUID = (Integer) UIDVector.elementAt(index);
    }
    else {
     System.out.println("Applications: application " + AID + " does not exist"); 
     tmpUID = new Integer(-1);
    }

    return tmpUID.intValue();


  }


  public void enableApp(int AID) {

    Integer tmp = new Integer(AID);
    int index;
  
    index = AIDVector.indexOf(tmp);

    if (index != -1) {

      Enabled.setElementAt(Boolean.TRUE, index);
      
    }
    else {
     System.out.println("Applications: application " + AID + " does not exist"); 
    
    }

  }
  
  public boolean isEnabledIndex(int index) {
  
    try {

      return ((Boolean) Enabled.elementAt(index)).booleanValue();
      
    } catch(Exception e) {
      
      System.out.println("Applications: err " + e);
      e.printStackTrace();
      return false;
      
    }
      
 }


 public void list() {


   int i;
   Integer AIDtmp;
   Integer UIDtmp;
   Integer SIDtmp;
   Boolean enabled;

   System.out.println("***************************");
   System.out.println("List of applications \n");

   for (i = 0; i < AIDVector.size(); i ++) {

     AIDtmp = (Integer) AIDVector.elementAt(i);
     UIDtmp = (Integer) UIDVector.elementAt(i);
     SIDtmp = (Integer) SIDVector.elementAt(i);
     enabled = (Boolean) Enabled.elementAt(i);

     System.out.println("AID " + AIDtmp.intValue() + " SID " + SIDtmp.intValue() + " UID " + UIDtmp.intValue() + " enabled " + enabled);
   }
     

 }


}















