// $Id: ComSessionTable.java,v 1.4 1998/07/10 20:15:51 beca Exp $
/*
File: ComSessionTable.java
Component: Server
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created

Tested:
OK

Notes:


*/

package webwisdom.tango.structures;

import webwisdom.tango.structures.ComSession;
import webwisdom.tango.messages.Message;
import webwisdom.tango.messages.EventMessage;
import webwisdom.tango.threads.ThreadOut;
import java.util.*;


public class ComSessionTable
{
    private static final String CL="ComSessionTable";
  
 
  private Hashtable SessionTable;
  private Hashtable AppTable;
  
  public ComSessionTable() {

   
    SessionTable = new Hashtable();
    AppTable = new Hashtable();
  }

  
 
  public void addSession(int SID) {
  
    ComSession s = new ComSession();
    Integer tmp;   
    boolean added;
  
    tmp = new Integer(SID);
    added = SessionTable.containsKey(tmp); 

   

    if (!added) {
      
      try {

	SessionTable.put(tmp, s);

      } catch(Exception e) {

	System.err.println(CL+".addSession(): session parameter invalid, cannot add" + e);	
					e.printStackTrace();

      }
	
    }
    else
     System.err.println(CL+".addSession(): session " + tmp + " already exist, cannot add");
   
  }


  public void addApplication(int SIDpar, ThreadOut THindex, int AIDpar) {

    

    Integer SIDint = new Integer(SIDpar);
    Integer AIDint = new Integer(AIDpar);
    ComSession s;
    boolean added;
   
   
    s = (ComSession) SessionTable.get(SIDint);

    if (s != null) {
      System.out.println(CL+".addApplication(): application " + AIDpar + "added to session " + SIDpar);     
      s.addApplication(THindex, AIDpar);

      if (!AppTable.containsKey(AIDint)) 
	AppTable.put(AIDint, SIDint);
    }
    else {

      System.err.println(CL+".addApplication(): session " + SIDpar + " does not exist, cannot add");

    }

  
  }

  private ComSession findSession(int AIDpar) { //return position of session in vector SessionVector

   
    ComSession s;
    Integer AIDint = new Integer(AIDpar);
    Integer SIDint;
    
    SIDint = (Integer) AppTable.get(AIDint); 
    
    if (SIDint != null) {

      s = (ComSession) SessionTable.get(SIDint);

    } else {

      System.err.println(CL+".findSession(): application " + AIDpar + " does not exist, cannot find session");
      s = null;

    }

    return s;  

  }


				     					  
  public void removeApplication(int AIDpar) {

   
    ComSession s;
    Integer AIDint = new Integer(AIDpar);
 
    s = findSession(AIDpar);

    if (s != null) {
     
      s.removeApplication(AIDpar);
      AppTable.remove(AIDint);
           
    } else {

     System.err.println(CL+".removeApplication(): application " + AIDpar + " does not exist");
    }
  }

  public void removeSession(int SIDpar) {

   
    Integer tmp = new Integer(SIDpar);
    ComSession s;
    Enumeration apps;
       
    s = (ComSession) SessionTable.remove(tmp);

    if (s != null) {

      apps = s.getApps();

      while(apps.hasMoreElements()) {

	AppTable.remove(apps.nextElement());

      }    
     
    }
    else {

     System.out.println(CL+".removeSession(): sesion " + SIDpar + " does not exist!");

    }
  }

  public synchronized void putMessage(Message a) {

    
    ComSession tmp;
    int number;    
    int index;
    EventMessage event = (EventMessage) a;
    int AID = event.getAID();   

    tmp = (ComSession) findSession(AID);

    if (tmp != null) {
      
      tmp.send(a);
    }

    else 
      System.err.println(CL+".putMessage(): application " + AID + " does not exist!"); 
      
    }
  
 
    public void list()
    {
      Enumeration k, e;
      ComSession s;
      k = SessionTable.keys();
      e = SessionTable.elements();
      System.out.println(CL+": Table of sessions:");
      while(k.hasMoreElements())
      {
	System.out.println("Sesssion " + k.nextElement() + " *****************");              
	s = (ComSession) e.nextElement();
	s.list();
      }
    }// list _______________________________________________________________
 
	
}// ComSessionTable ////////////////////////////////////////////////////////


