// $Id: DbSessions.java,v 1.4 1998/07/10 20:15:52 beca Exp $
/*
File: DbSessions.java
Component: Server
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created

Tested:
OK

Notes:


*/

package webwisdom.tango.structures;

import java.util.*;
import webwisdom.tango.consts.Const;


public class DbSessions
{
    private static final String CL="DbSessions";


  private Vector ATVector;
  private Vector SIDVector;
  private Vector MasterVector;
  private Vector Enabled;


  public DbSessions() {
    ATVector = new Vector();
    SIDVector = new Vector();
    MasterVector = new Vector();
    Enabled = new Vector();

  }

 public void addSession(int SID, int AT, int masterUID) {

    Integer a = new Integer(SID);
    Integer b = new Integer(AT);
    Integer c = new Integer(masterUID);    
    Boolean d = Boolean.FALSE;
    int index;
    
    index = SIDVector.indexOf(a);

    if (index == -1) {

      SIDVector.addElement(a);
      ATVector.addElement(b);
      MasterVector.addElement(c);
      Enabled.addElement(d);
    }
    else 

      System.out.println(CL+".addSession(): session " + SID + " already exists!");

   

  }

  public int getMaster(int SID) {   

    Integer result;

    Integer SIDpar = new Integer(SID);

    int index;
   

    index = SIDVector.indexOf(SIDpar);
    
    if (index != -1) {

      result = (Integer) MasterVector.elementAt(index);
    }
    else {

      result = new Integer(-1);
      System.err.println(CL+".getMaster(): session " + SID + " does not exist!");
    }
      
    return result.intValue();

  }




  public void removeSession(int SIDpar) {

    int index;
    Integer SID = new Integer(SIDpar);

    index = SIDVector.indexOf(SID);
    
    if (index != -1) {

      SIDVector.removeElementAt(index);
      ATVector.removeElementAt(index);
      MasterVector.removeElementAt(index);
      Enabled.removeElementAt(index);
    }
    else {
       System.err.println(CL+".removeSession(): session " + SIDpar + " does not exist!");
    }

  }

  public void changeMaster(int SIDpar, int UIDpar) {

    Integer SID = new Integer(SIDpar);
    Integer master = new Integer(UIDpar);
    int index;
   

    index = SIDVector.indexOf(SID);
    
    if (index != -1) {

      MasterVector.setElementAt(master, index);
    }
    else {

      System.err.println(CL+".changeMaster(): session " + SID + " does not exist!");
    }
      


  }


    public void list()
    {
      int i;
      Integer tmpSID;
      Integer tmpAT;
      Integer tmpMaster;

      System.out.println(CL+".list():");
      for (i = 0; i < SIDVector.size(); i ++)
      {
	tmpSID = (Integer) SIDVector.elementAt(i);
	tmpAT = (Integer) ATVector.elementAt(i);
	tmpMaster = (Integer) MasterVector.elementAt(i);
	System.out.println(" SID="+tmpSID.intValue()+
			   " AT="+tmpAT.intValue()+
			   " master="+tmpMaster.intValue());
      }
    }// list _______________________________________________________________


   public int getType(int SIDpar) {

    int result;  
    Integer tmp = new Integer(SIDpar);
    int index;
    Integer tmpAT;

    index = SIDVector.indexOf(tmp);
    
    if (index != -1) {
      
      tmpAT = (Integer) ATVector.elementAt(index);
      result = tmpAT.intValue();
    }
    else {

      System.err.println(CL+".getType(): session " + SIDpar + " does not exist!");
      result = Const.UNDEFINED;
    }

    return result;
    

  }

    public int getAT(int index) {

    Integer tmp;

    tmp = (Integer) ATVector.elementAt(index);
    
    return tmp.intValue();
  
  }  

   public int getSID(int index) {

    Integer tmp;

    tmp = (Integer) SIDVector.elementAt(index);
    
    return tmp.intValue();
  
  }  

   public int getMasterUID(int index) {

    Integer tmp;

    tmp = (Integer) MasterVector.elementAt(index);
    
    return tmp.intValue();
  
  }  

  public int getSize() {

    return SIDVector.size();

  }
  
  public boolean isEnabledIndex(int index) {
  
      return((Boolean) Enabled.elementAt(index)).booleanValue();
  }

    
  public boolean isEnabled(int SID) {
    
    Integer tmp = new Integer(SID);
    int index;
  
    index = SIDVector.indexOf(tmp);

    if (index != -1) {

      return ((Boolean) Enabled.elementAt(index)).booleanValue();      
    }
    else {
     System.err.println(CL+".isEnabled(): session " + SID + " does not exist!"); 
     return false;
    }

   
  } 

  
   
  public void enableSession(int SID) {
  
    Integer tmp = new Integer(SID);
    int index;
  
    index = SIDVector.indexOf(tmp);

    if (index != -1) {

      Enabled.setElementAt(Boolean.TRUE, index);
      
    }
    else {
     System.err.println(CL+".enableSession(): session " + SID + " does not exist!"); 
      
    }

   
  } 
   
}





