// $Id: LocalBase.java,v 1.16 1998/11/03 00:53:06 piotr Exp $
/*
  File: LocalBase.java
  Component: Plugin
  Date		Author		Changes
  Mar 07 97	Lukasz Beca	Created
*/

package webwisdom.tango.structures;

import webwisdom.tango.consts.Const;
import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.structures.CentralServer;
import webwisdom.tango.structures.ControlApplication;
import webwisdom.tango.structures.Registrar;
import webwisdom.tango.interfaces.PureJavaInterface;
import netscape.plugin.Plugin;
import webwisdom.tango.structures.ScriptHandle;
import netscape.javascript.JSObject;
import netscape.security.PrivilegeManager;

import java.util.StringTokenizer;


public class LocalBase extends Plugin
{
    private static final String CL="LocalBase";

    //////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////
    // DO NOT EDIT THE NEXT LINE!  IT WILL BE GENERATED AUTOMATICALLY!
    private static String compilationDate = "*Build: Fri Oct  9 14:09:10 EDT 1998*";
    //////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////
    
    private String serverHost;
    private int serverPort,localPort;

    private ControlApplication ca;
    public Registrar reg;


    private static LocalBase localBase1=null;
    private static LocalBase localBase2=null;
    private static boolean inTango = false;  // necessary for NN tango


  public LocalBase()
    {
      if(Const.inNetscape())
	{
	  StringTokenizer st=new StringTokenizer(compilationDate,"*");
	  System.out.println(CL+": TANGO Interactive Plugin, "+st.nextToken());


	  serverHost=new String(getServerHost());
	  if(serverHost==null)
	    throw new Error("serverHost=null");
	  if(serverHost.equals("*"))
	    throw new Error("serverHost=\"*\" (invalid)");

	  serverPort=getServerPort();
	  if(serverPort==-1)
	    throw new Error("serverPort=-1");

	  localPort=getLocalPort();
	  if(localPort==-1)
	    throw new Error("localPort=-1");
	}
      else
	{ 
	  PureJavaInterface pji=PureJavaInterface.getPureJavaInterface();
	  serverHost=pji.getHost();
	  serverPort=pji.getServerPort();
	  localPort=pji.getLocalPort();
	}

      System.out.println(CL+".LocalBase(): server="+serverHost+
			 ":"+serverPort+" localPort="+localPort);

      ca=new ControlApplication();
      reg=new Registrar(localPort, this, ca);

      //System.out.println(CL+".LocalBase(): ca="+ca+" reg="+reg);
	
      inTango = true;  // in tango set	
      localBase2=this;
    }// LocalBase __________________________________________________________

  public LocalBase(String str) {
  
  
  }

  public static LocalBase getLocalBase()
    {
     	localBase1=new LocalBase("empty");
      return localBase1;
    }// getLocalBase _______________________________________________________
  
  
  public static LocalBase getOtherLocalBase()
  
   {
     if(localBase2==null)
	localBase2=new LocalBase();
      return localBase2;
  }

    public static String getPluginVersion()
    {
	    return "1.02";
    }

    public void init()
    {
         System.out.println(CL+".init()");
    }// init _______________________________________________________________

    
    public void destroy()
    {
	System.out.println(CL+".destroy()");
	ca.terminated();
	ca=null;
	reg=null;
    }// destroy ____________________________________________________________


    /**interface for ControlApplication*/
    
    public synchronized void connect() {
    
      System.out.println(CL+".connect()");
      PrivilegeManager.enablePrivilege("30Capabilities");
      LocalApplications apps=new LocalApplications();   
      reg.initAssociations(apps);        
      CentralServer cs=new CentralServer(serverHost,serverPort);
      ca.initAssociations(this,cs,apps,reg);
      cs.initAssociations(ca,apps);
      apps.initAssociations(ca,cs);
      System.out.println(CL+".connect(): end");
	    
    }// connect ____________________________________________________________
    
    
    public synchronized void startApplication(String path,
					      int AID,int SID,int AT,
					      int localport)
    {
	runApplication(path,AID,SID,AT,localport);
    }// startApplication ___________________________________________________


    /**interface for scripts
     not used with new api*/
    public ScriptHandle addScript(JSObject window,
				  String AIDs,String SIDs,String ATs)
    {
        if (!inTango) {
	
		      System.out.println(CL + " not in tango, return NNScriptHandle");
		      return new NNScriptHandle(window, AIDs, SIDs, ATs);
	
	      } else 
    
			    return reg.registerScript(window, AIDs, SIDs, ATs);
    }// addScript __________________________________________________________
   

    private native int runApplication(String path,
				      int AID,int SID,int AT,
				      int port);
    // runApplication ______________________________________________________
   

    /**
     *@return "*" if not available*/
    private native String getServerHost();
    // getServerHost _______________________________________________________


    /**
     *@return -1 if not available*/
    private native int getServerPort();
    // getServerPort _______________________________________________________


    /**
     *@return -1 if not available*/
    private native int getLocalPort();
    // getLocalPort ________________________________________________________
  

}// LocalBase //////////////////////////////////////////////////////////////
