// $Id: MessageQueue.java,v 1.4 1998/07/10 20:15:55 beca Exp $
/*
File: MessageQueue.java
Component: Server, Plugin
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


package webwisdom.tango.structures;


import java.util.*;
import webwisdom.tango.messages.Message;
import webwisdom.tango.messages.EmptyMessage;


public class MessageQueue extends Vector
{
    private static final String CL="MessageQueue";


    public MessageQueue()
    {
      super();
    }// MessageQueue _______________________________________________________
  

    public synchronized void putMessage(Message m)
    {
      this.addElement(m);
      notify();
    }// putMessage _________________________________________________________


    public synchronized Message getMessage()
    {
      while(this.isEmpty())
      {
	try
	{
	  wait();
	}
	catch(InterruptedException e)
	{
	  System.err.println(CL+".getMessage(): wait() interrupted!: "+e);
	  e.printStackTrace();
	}
      }
      Message m=(Message)this.firstElement();
      this.removeElementAt(0);	
      return m;
    }// getMessage _________________________________________________________


    public synchronized void unblock()
    {
      EmptyMessage m=new EmptyMessage();
      this.addElement(m);
      notify();
    }// unblock ____________________________________________________________

	
    public synchronized boolean empty()
    {
      return this.isEmpty();
    }// empty ______________________________________________________________


    public synchronized void clear()
    {
      this.removeAllElements();
    }// clear ______________________________________________________________


}// MessageQueue ///////////////////////////////////////////////////////////


