// $Id: $
/*
File: NNConnection.java
Component: Plugin
Date		Author		Changes		
Nov 04 98	Lukasz Beca	Created
*/


package webwisdom.tango.structures;

import webwisdom.tango.structures.Handle;
import webwisdom.tango.threads.AppThreadIn;
import webwisdom.tango.threads.AppThreadOut;
import webwisdom.tango.messages.Message;
import java.net.Socket;
import webwisdom.tango.messages.*;
import webwisdom.tango.consts.*;

public class NNConnection implements Runnable {

    private MessageQueue q;
    private AppNet n;
    private Thread th;
    private boolean exit;     
    private NNScriptHandle nnHandle;

    

    static int number=1;    //for testing only
    int thisno;  //for testing only


  public NNConnection(Socket s, NNScriptHandle nnsh, int AID, int SID, int AT) {

      thisno=number;
      number++;

      n=new AppNet(s);
      
      
      try {
	      n.send(AID);
	      n.send(SID);
	      n.send(AT);
	    } catch(Exception e) {
	    
	      e.printStackTrace();
	    
	    }
      
      q=new MessageQueue();
      th=new Thread(this);
      exit=false;
      nnHandle = nnsh;
      th.start();

               
  }
   
  public synchronized void sendAppToOther(Message mesg) {
  
    putMessage(mesg);
  
  }
  
    private static final String CL="NNConnection";


     

    public void run()
    {
      System.out.println(CL+".run(): "+thisno);
      while(!exit)
      {
	Message m=q.getMessage();
	try
	{
	  n.send(m);
          //System.out.println(CL+": "+thisno+" sending "+m);
	}
	catch(Exception e)
	{
	  System.err.println(CL+": error sending message: "+e);
	  e.printStackTrace();
	}
      }
    }// run ________________________________________________________________


    public synchronized void putMessage(Message m)
    {
      q.putMessage(m);
    }// putMessage _________________________________________________________

 
    public void stop()
    {
      //System.out.println(CL+".stop()");
      exit = true;
      q.unblock();
         
    }// stop _______________________________________



  public void setFocus() {

  }
  
  public synchronized void finish() {

 //   System.out.println("ApplicationHandle: terminating application ");
    nnHandle.remove();
 

  }
}



