// $Id $
/*
File: NNScriptHandle.java
Component: Plugin
Date		Author		Changes		
Nov 04 98	Lukasz Beca	Created

*/

package webwisdom.tango.structures;

import webwisdom.tango.structures.Handle;
import webwisdom.tango.interfaces.AppletBase;
import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.messages.EmptyMessage;
import webwisdom.tango.messages.Message;
import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.messages.EventMessage;
import webwisdom.tango.consts.Const;
import netscape.javascript.JSObject;
import webwisdom.tango.messages.CAppRequestEventMessage;
import webwisdom.tango.messages.CAppAnswerEventMessage;
import webwisdom.tango.consts.CAConsts;
import java.net.*;
import webwisdom.tango.messages.AppNet;

public class NNScriptHandle extends ScriptHandle implements Runnable {
    private static final String CL="NNScriptHandle";


  private JSObject script;
  private int AID;
  private Socket socket;
  private AppNet an;
  //private LocalApplications lapps;

  private NNConnection connection;

//  private MessageQueue q;
  private boolean exit; 
  private Thread th;
  
  final static int DATA = 1;
  final static int CONTROL = 0;

  public NNScriptHandle(JSObject s, String AIDpar, String SIDpar, String ATpar) {

    script = s;
    AID = Integer.parseInt(AIDpar);
    
    
  	 netscape.security.PrivilegeManager.enablePrivilege("30Capabilities");
	    
    try {
      socket = new Socket(InetAddress.getLocalHost(), 8000);
    
    
    } catch(Exception e) {
    
      e.printStackTrace();
      
    }
    
    an = new AppNet(socket);        
    th = new Thread(this);
    exit = false;
    th.start();

    connection = new NNConnection(socket, this, Integer.parseInt(AIDpar),Integer.parseInt(SIDpar), Integer.parseInt(ATpar));
    
    
    
    System.out.println("NNScriptHandle created " + AIDpar + " " +  SIDpar + " " + ATpar);
    
  }

  public void run() {

    Message m;
    //AppEventMessage am;
    CAppAnswerEventMessage cam;
    AppEventMessage aem;
    //Object args[] = new Object[1];
    Object args[] = new Object[2];
    int type;
    //byte data[];
    int ctype;

   

    System.out.println("ScriptHandle: script thread number " + AID+ "  started");
   
    
    while(!exit) {

      System.out.println("ThreadOut: Thread number sending");
      
      try {
      
	      m = an.receive();	
	      
	    } catch(Exception e) {
	    
        e.printStackTrace();	    
	      System.out.println(CL+": IOException!: removing application");
	      m=null;	   	
	      remove();
	      break;	    
	    }
	    
	    

   	if (!exit) {
	 
	  type = m.getType();

	  if (type == Const.CONTROL) {
	    
	    
	    
	    aem = (AppEventMessage) m;  
	    
	    cam = new CAppAnswerEventMessage(aem.getData());
	    ctype = cam.getAnswerType();
	    if (ctype == CAConsts.ISMASTER) {	    	      

	      if (cam.isMaster()) {

		script.call("Tango_setMaster", null); 			
	

	      } else {

		script.call("Tango_setSlave", null);
	
	      }
	     
	    }
	  }

// 	  else {
// 	    am = (AppEventMessage) m;
// 	    data = am.getData();
// 	    args[0] = bytesToString(data);
// 	    script.call("Tango_receive", args); 
// 	  }
	  else
	  {
	    AppEventMessage am=(AppEventMessage)m;
	    byte[] data=am.getData();
	    int chId=(int)data[0];
	    int chDataLen=data.length-1;
	    if(chId==-128)/*Strings, no channels*/
	    {
	      String chData=new String(data,0,1,chDataLen);
	      args[0]=chData;
	      script.call("Tango_receive",args);
	    }
	    else if(chId>=0)/*bytes*/
	    {
	      String chName=String.valueOf(chId);
	      byte[] chData=new byte[chDataLen];
	      for(int i=0;i<chDataLen;i++)
		chData[i]=data[1+i];
	      args[0]=chName;args[1]=chData;
	      script.call("Tango_receiveBytes",args);
	    }
	    else/*Strings*/
	    {
	      chId=-chId;
	      String chName=String.valueOf(chId);
	      String chData=new String(data,0,1,chDataLen);
	      args[0]=chName;args[1]=chData;
	      script.call("Tango_receiveString",args);
	    }
	  }
	      
	}
	      
    }

  }

    /*The following 3 functions concatenate channel id and channel data
      into one message:
      first byte - channel number, remaining bytes - data.
      As channels are represented by one byte
      the channel number must be within [-128,127].
      Api with Strings uses channels [-128,-1], with bytes - [0,127].
      Default channel for Strings api without channels is -128.
      User uses channels [0,127] only,
      the rest is used to save information which api is in use.*/


    /**Sends byte[] through the given channel.
     *@param chName channel name (must represent a number 0-127) eg "13"
     *@param chData channel data*/
    public void putBytesMessage(String chName,byte[] chData)
    {
      int chId=Integer.valueOf(chName).intValue();
      int chDataLen=chData.length;
      byte[] data=new byte[1+chDataLen];
      data[0]=(byte)chId;
      for(int i=0;i<chDataLen;i++)
	data[1+i]=chData[i];
      connection.sendAppToOther(new AppEventMessage(Const.DATA,data));
    }// putBytesMessage ____________________________________________________


    /**Sends String through the given channel.
     *@param chName channel name (must represent a number 1-127) eg "14"
     *@param chData channel data*/
    public void putStringMessage(String chName,String chData)
    {
      int chId=-Integer.valueOf(chName).intValue();
      int chDataLen=chData.length();
      byte[] data=new byte[1+chDataLen];
      data[0]=(byte)chId;
      chData.getBytes(0,chDataLen,data,1);
      connection.sendAppToOther(new AppEventMessage(Const.DATA,data));
    }// putBytesMessage ____________________________________________________


    /**Sends String by default channel.
     *@param chData data
     *@see #putStringMessage*/
    public void putMessage(String chData)
    {
      int chDataLen=chData.length();
      byte[] data=new byte[1+chDataLen];
      data[0]=(byte)-128;
      chData.getBytes(0,chDataLen,data,1);
      //l.sendServer(new EventMessage(AID,data));
      connection.sendAppToOther(new AppEventMessage(Const.DATA,data));
    }// putMessage _________________________________________________________


//   public void putMessage(String info) {

//     byte data[] = stringToBytes(info); 
//     AppEventMessage a;
   
//     a = new AppEventMessage(Const.DATA, data);
//     lapps.sendAppToOther(AID, a);
 

//   }


  public void askMaster() {

     byte[] tab = new byte[1];
     tab[0] = 1; //question if applet is a master or not
     CAppRequestEventMessage mes = new CAppRequestEventMessage(tab);  
	
     connection.sendAppToOther(mes);
    
  }


/*  public void sendLAToApp(Message m) {
    

       q.putMessage(m);

  }*/

  
  public void finish() {

       script.call("Tango_finish", null);
//     script.eval("close();");

  }

  public void remove() {
 //    System.out.println("ScriptHandle: removing script " + AID);
     exit = true;
  //   q.unblock();
     connection.stop();
     an.close();
     JSObject parent=(JSObject)script.getMember("top");
     script.eval("close();");
     parent.eval("close();");
  }

  public void setFocus() {

     script.eval("focus();");
  }
  

//   private String bytesToString(byte data[]) {

//     String result;

//     result = new String(data, 0);

//     return result;

//   }


//   private byte[] stringToBytes(String data) {

//     byte result[];
//     int len;

//     len = data.length();
//     result = new byte[len];
//     data.getBytes(0, len, result, 0);

//     return result;

//   }


    public String toString()
    {
      return CL+"[aid="+AID+",scr="+script+"]";
    }// toString ___________________________________________________________


}





