// $Id: Participants.java,v 1.3 1998/07/10 20:15:56 beca Exp $
/*
File: Participants.java
Component: Server
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created

Tested:
OK

*/

package webwisdom.tango.structures;

import java.util.*;

public class Participants {

  private Vector UIDVector;
  private Vector HostVector;
  private Vector IPVector;

  public Participants() {

     UIDVector = new Vector();
     HostVector = new Vector();
     IPVector = new Vector();
  }

  public synchronized void addParticipant(int UIDpar, String hostpar, String ippar) {
    
    Integer a = new Integer(UIDpar);
    int index;
    
    index = UIDVector.indexOf(a);

    if (index == -1){
      UIDVector.addElement(a);
      HostVector.addElement(hostpar);
      IPVector.addElement(ippar);
    }
    else 
      System.out.println("Participants: user " + UIDpar + " already logged in from host " + (String) HostVector.elementAt(index) + " , cannot add");
    
  }
    

  public synchronized void deleteParticipant(int UIDpar) {

    Integer UID = new Integer(UIDpar);

    int index;

    index = UIDVector.indexOf(UID);
    if (index != -1) {
    
      UIDVector.removeElementAt(index);
      HostVector.removeElementAt(index);
      IPVector.removeElementAt(index);
    }
	
    else System.out.println("Participants: user " + UIDpar + " is not logged in, cannot remove");

  }

  public synchronized String getHost(int UIDpar) {

    Integer UID = new Integer(UIDpar);

    int index;
    String result;

    index = UIDVector.indexOf(UID);
    if (index != -1) {

      result = (String) HostVector.elementAt(index);
    }
	
    else {
      System.out.println("Participants: user " + UIDpar + " is not logged in, cannot get host");
      result = null;
    }

    return result;

  }
  
  public synchronized String getIP(int UIDpar) {
  
     Integer UID = new Integer(UIDpar);

     int index;
     String result;

     index = UIDVector.indexOf(UID);
     if (index != -1) {

       result = (String) IPVector.elementAt(index);
     }
	
     else {
       System.out.println("Participants: user " + UIDpar + " is not logged in, cannot get ip");
      result = null;
     }

     return result;     	
  
  }
  

  public synchronized Vector getUsers() {
   
   return UIDVector;

  }

  public synchronized boolean isLoggedIn(int UID) {

    Integer tmp = new Integer(UID);
    

    return UIDVector.contains(tmp);
    


  }

  

  

  public void list() {

    int i;
    Integer utmp;
    String htmp;

    System.out.println("Participants ****************");

    for (i = 0; i < UIDVector.size(); i ++) {

      utmp = (Integer) UIDVector.elementAt(i);
      htmp = (String) HostVector.elementAt(i);

       System.out.println("User " + utmp + " host " + htmp);
    }

  }
}

