// $Id: Registrar.java,v 1.9 1998/10/29 22:49:43 beca Exp $
/*
File: Registrar.java
Component: Plugin
Date		Author		Changes
Mar 07 97	Lukasz Beca	Created
11  13 97   K Olszewski changed application start
*/


package webwisdom.tango.structures;


import java.net.SocketException;
import java.io.IOException;
import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.structures.ControlApplication;
import webwisdom.tango.interfaces.ControlAppletBaseInterf;
import webwisdom.tango.interfaces.AppletBaseInterf;
//import webwisdom.tango.interfaces.ScriptBaseInterf;
import webwisdom.tango.structures.ApplicationHandle;
import webwisdom.tango.structures.AppletHandle;
//import webwisdom.tango.structures.ScriptHandle;
//import webwisdom.tango.structures.NewScriptHandle;
//import webwisdom.tango.structures.BeanHandle;
//import webwisdom.tango.beans.TangoBean;
import java.net.ServerSocket;
import java.net.Socket;
import netscape.javascript.JSObject;
import webwisdom.tango.threads.AppThreadIn;
import webwisdom.tango.threads.AppThreadOut;
import webwisdom.tango.consts.Const;
import netscape.security.PrivilegeManager;

import webwisdom.tango.threads.AcceptThread;

public class Registrar
{
    private static final String CL="Registrar";


    private LocalApplications apps;
    private ControlApplication ca;
    private AcceptThread accth;
    private LocalBase lb;
    private int port;
  

    public Registrar(int portpar, LocalBase locbase, ControlApplication conapp)
    {
      apps=null;
      ca=conapp;
      lb = locbase;
      port=portpar;

    }// Registrar __________________________________________________________


    //interface for LocalBase
    //public void initAssociations(ControlApplication ca,LocalApplications la);
  

    public void initAssociations(LocalApplications lapar)
    {
      //System.out.println(CL+".initAssociations("+capar+")");
      apps=lapar;
    }// initAssociations ___________________________________________________

 

    //interface for Control Application
    //public ControlApplication registerCA(ControlAppletBaseInterf cab);
    //public int getLocalPort();
    //public void end();


    public ControlApplication registerCA(ControlAppletBaseInterf cab)
    {
      System.out.println(CL+".registerCA("+cab+"): ca="+ca);
      if(ca!=null)
      { 
        if(port>0)
		      {
			    		initSocket();
		      } else {
		      
			      port=0;
				    accth=null;
			      ca.errorRegistrar(Const.FILEWRONGFORMAT);
		      }

	    
		      lb.connect();
		      ca.init(cab);
      }
      return ca;
    }// registerCA _________________________________________________________


    public int getLocalPort()
    {
      return port;
    }// getLocalPort _______________________________________________________

  
    public void end()
    {
      apps = null;
      ca = null;
      accth.stop();
      accth = null;
      port = 0;
    }// end ________________________________________________________________


    //interface for Applets
    //public void registerApplet(AppletBase ab);  

    public AppletHandle registerApplet(AppletBaseInterf applet,
				       int AID, int SID, int AT)
    {
      WindowAppletHandle h = new WindowAppletHandle(applet, AID, apps);
      //   System.out.println("Registrar: new applet registered with AID" + AID + " SID " + SID + " AT " + AT);	
      apps.addApplication(h, AID, SID);
      ca.addApplication(AID, SID, AT);
      return h;
    }// registerApplet _____________________________________________________

    public AppletHandle registerFrameApplet(AppletBaseInterf applet,
				       int AID, int SID, int AT, String frameName)
				       
		// url contains default content of the empty frame		       
    {
      
	    String url;
	    
	    url = ca.getDefaultContent(frameName);
	    
      FrameAppletHandle h = new FrameAppletHandle(applet, AID, apps, url);
      System.out.println("Registrar: new applet registered with AID" + AID + " SID " + SID + " AT " + AT);	
      apps.addApplication(h, AID, SID);
      ca.addApplication(AID, SID, AT);
      return h;
    }// registerFrameApplet _____________________________________________________




    //interface for Scripts
    //public void registerScript(JSObject script);

//     public ScriptHandle registerScript(ScriptBaseInterf sb,JSObject script,
// 				       String AIDs, String SIDs, String ATs)
//     {
//       int SID, AT, AID;
//       ScriptHandle h;
//       try
//       {   
// 	AID = Integer.parseInt(AIDs);
// 	SID = Integer.parseInt(SIDs);
// 	AT = Integer.parseInt(ATs);
// 	//	 System.out.println("Registrar: script AID " + AID + " SID " + SID + " AT " + AT);
// 	h = new ScriptHandle(sb,script, AID, apps);
//     	//	System.out.println("Registrar: new script registered with AID" + AID + " SID " + SID + " AT " + AT);	
// 	apps.addApplication(h, AID, SID);
// 	ca.addApplication(AID, SID, AT);
//       }
//       catch(Exception e)
//       {
//         System.err.println(CL+".registerScript("+AIDs+"): AID not found!");
// 	e.printStackTrace();
// 	return null;
//       }
//       return h;
//     }// registerScript _____________________________________________________
  
  
    public ScriptHandle registerScript(JSObject script,
				       String AIDs, String SIDs, String ATs)
    {
      int SID, AT, AID;
      ScriptHandle h;
      try
      {   
	AID = Integer.parseInt(AIDs);
	SID = Integer.parseInt(SIDs);
	AT = Integer.parseInt(ATs);
	//	 System.out.println("Registrar: script AID " + AID + " SID " + SID + " AT " + AT);
	h = new ScriptHandle(script, AID, apps);
    	//	System.out.println("Registrar: new script registered with AID" + AID + " SID " + SID + " AT " + AT);	
	apps.addApplication(h, AID, SID);
	ca.addApplication(AID, SID, AT);
      }
      catch(Exception e)
      {
        System.err.println(CL+".registerScript("+AIDs+"): AID not found!");
	e.printStackTrace();
	return null;
      }
      return h;
    }// registerScript _____________________________________________________
  
  
 //   public AppletHandle registerNewScript(AppletBaseInterf sb,
//					     int AID,int SID,int AT)
//    {
//      System.out.println(CL+".registerScript("+AID+","+SID+","+AT+")");
//      try
//      {   
//	AppletHandle h=new AppletHandle(sb,AID,apps);
//	apps.addApplication(h,AID,SID);
//	ca.addApplication(AID,SID,AT);
//	return h;
//      }
//      catch(Exception e)
//      {
//        System.err.println(CL+".registerScript("+AID+"): AID not found!");
//	e.printStackTrace();
//	return null;
//      }
//    }// registerScript _____________________________________________________
  
  
    //interface for Beans
    //public void registerBean();

 //   public BeanHandle registerBean(TangoBean tb, JSObject window,
//				   int AID, int SID, int AT)
 //   {
 //     BeanHandle h;
//      try
//      {   
      	//	System.out.println("Registrar: script AID " + AID + " SID " + SID + " AT " + AT);
//	h = new BeanHandle(tb, window, AID, apps);
    	//	System.out.println("Registrar: new bean registered with AID" + AID + " SID " + SID + " AT " + AT);	
  //  	apps.addApplication(h, AID, SID);
//	ca.addApplication(AID, SID, AT);
 //     }
 //     catch(Exception e)
   //   {
   //     System.err.println(CL+".registerBean("+AID+"): AID not found!");
//	e.printStackTrace();
//	return null;
  //    }
  //    return h;
 //   }// registerBean _______________________________________________________


    //interface for AppThreadIn (Applications)
    //public void registerApplication();

    public ApplicationHandle registerApplication(AppThreadIn in,
						 AppThreadOut out,
						 int AID,int SID,int AT)
    {
      ApplicationHandle apph;
      apph = new ApplicationHandle(in, out);    
      apps.addApplication(apph, AID, SID); 
      ca.addApplication(AID, SID, AT);  
      return apph;
    }// registerApplet _____________________________________________________


    //inteface for AcceptThread
    //public void errorAcc();
    //public void handleConnection(Socket sock);
 
    public void errorAcc()
    {
    }// errorAcc ___________________________________________________________
  

    public void handleConnection(Socket sock)
    {
      AppThreadIn i;
      AppThreadOut o;
      if(sock != null)
      {
	System.out.println(CL+".handleConnection()");
	o = new AppThreadOut(sock);
	i = new AppThreadIn(sock, o, apps, this);
      }
    }// handleConnection ___________________________________________________


    //internal methods
    //private void initSocket();

    private void initSocket()
    {
      PrivilegeManager.enablePrivilege("30Capabilities");

      ServerSocket s=null; 

      boolean connected=false; 
      int bound=port+100;
      while((!connected)&&(port<bound))
      {
	try
	{
	  s=new ServerSocket(port);
	  connected=true;
	  s.setSoTimeout(600000);
	}
	catch(SocketException e)
	{
	  System.err.println(CL+".initSocket(): setSoTimeout() failed! "+e+": ignoring");
	  //e.printStackTrace();
	  break;
	}
	catch(IOException e)
	{
	  System.out.println(CL+".initSocket(): "+e+": trying another port");
	  port++;
	  continue;
	}
      }

      if(port==bound)
      {
	System.err.println(CL+".initSocket(): no port available!");    
	ca.errorRegistrar(Const.UNABLETOLISTEN);
	return;
      }

      accth=new AcceptThread(s,this);
    }// initSocket _________________________________________________________

	
    private void addApplication(int AID, int SID, int AT)
    {
      ca.addApplication(AID, SID, AT);
    }// addApplication _____________________________________________________


    public String toString()
    {
      return CL;
    }// toString ___________________________________________________________


}// Registrar //////////////////////////////////////////////////////////////

