// $Id: Users.java,v 1.4 1998/07/10 20:15:58 beca Exp $
/*
File: Users.java
Component: Server
Date		Author		Changes
Aug 25 96	Lukasz Beca	Created
Oct 07 96       Lukasz Beca     Reading from file added
Tested:
OK

*/
package webwisdom.tango.structures;


import java.lang.*;
import java.util.*;
import java.io.*;

public class Users
{
    private static final String CL="Users";


    private Vector UIDVector;
    private Vector NameVector;
    private Vector PasswdVector;
    private Vector PrivVector;
    
    // distribution
    private int currentUID;


    public Users()
    {
      UIDVector = new Vector();
      NameVector = new Vector();
      PasswdVector = new Vector();
      PrivVector = new Vector();
      currentUID = 1;
    }


    public synchronized void addUser(String name,String passwd,String privpar)
    {
      int UID = newUID();
      Integer a = new Integer(UID);
      UIDVector.addElement(a);
      NameVector.addElement(name);
      PasswdVector.addElement(passwd);
      PrivVector.addElement(privpar);
      System.out.println(CL+"addUser("+name+"): UID="+UID);
    }


  public synchronized void removeUser(int UID) {

    int index;
    String result;
    Integer tmp = new Integer(UID);
    index = UIDVector.indexOf(tmp);
   
    if (index == -1) {
      System.err.println(CL+".removeUser("+UID+"): no such user!");
    }
    else {

      UIDVector.removeElementAt(index);
      NameVector.removeElementAt(index);
      PasswdVector.removeElementAt(index);
      PrivVector.removeElementAt(index);
      System.out.println(CL+".removeUser("+UID+"): OK");
    }
    
  }
   


  public synchronized String getPasswd(String name) {

    int index;
    String result;

    index = NameVector.indexOf(name);
    
    if (index == -1) { 
      System.err.println(CL+".getPasswd(): user " + name + " does not have an account!");
      result = null;
    }
    else
      result = (String) PasswdVector.elementAt(index); 

    return result;

  }

  public synchronized String getName(int UID) {

    int index;
    String result;
    Integer tmp = new Integer(UID);

    index = UIDVector.indexOf(tmp);
    
    if (index == -1) {
      System.out.println(CL+".getName(): user " + UID + " does not have an account!");
      result = null;
    }
    else
      result = (String) NameVector.elementAt(index); 

    return result;

  }

   public synchronized String getPriv(int UID) {

    int index;
    String result;
    Integer tmp = new Integer(UID);

    index = UIDVector.indexOf(tmp);
     
    if (index == -1) {
      System.err.println(CL+".getPriv(): user " + UID + " does not have an account!");
      result = null;
    }
    else
      result = (String) PrivVector.elementAt(index); 

    return result;

  }



  public synchronized int getUID(String name) {
 
    //gets UID of name, if name does not exist in Users then 0 is returned   
  
    int index;
    int result;
    Integer tmp;

    index = NameVector.indexOf(name);
    if (index == -1) {
       System.err.println(CL+".getUID(): user " + name + " does not have an account!");
      result = -1;
    }
    else {
      tmp = (Integer) UIDVector.elementAt(index);
      result = tmp.intValue();
    }

    return result;
    
  }


    //checks whether password is ok
    //returns UID if password is valid, otherwise 0
    public synchronized int checkPasswd(String name, String passwd)
    {
      String p;
      int result;
      p = getPasswd(name);
      if (p != null)
	if (p.equals(passwd) ) 
	  result = getUID(name);
	else
	  result = 0;
      else
	result = 0;
      
      return result;
    }// checkPasswd ________________________________________________________


    private int newUID()
    {
      int tmp;
      tmp = currentUID;
      currentUID ++;
      return tmp;
    }// newUID _____________________________________________________________


}// Users //////////////////////////////////////////////////////////////////












