// $Id: AppThreadIn.java,v 1.5 1998/07/10 20:16:01 beca Exp $
/*
File: AppThreadIn.java
Component: Plugin
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


package webwisdom.tango.threads;


import java.lang.*;
import java.net.*;
import java.io.*;
import webwisdom.tango.messages.AppNet;
import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.consts.Const;
import webwisdom.tango.protocols.ApplicationProtocol;
import webwisdom.tango.threads.AppThreadOut;
import webwisdom.tango.structures.LocalApplications;
import webwisdom.tango.structures.Registrar;
import webwisdom.tango.structures.ApplicationHandle;


/**Demon thread.*/
public class AppThreadIn extends ApplicationProtocol implements Runnable
{
    private static final String CL="AppThreadIn";
  

    private AppNet n;
    private AppThreadOut out;
    private Thread th;   //reference to this thread 
    private boolean exit;
    private Registrar reg;
    

    public AppThreadIn(Socket s,AppThreadOut outpar,
		       LocalApplications localpar,Registrar regpar)
    {
      super(localpar);
      out = outpar; 
      reg = regpar;  
      n = new AppNet(s);   
      th = new Thread(this);
      exit = false;
      th.start();
     }// AppThreadIn ________________________________________________________

 
    public void run()
    {
      //System.out.println(CL+".run()");
      int AIDtmp = n.getData();
      int SIDtmp = n.getData();
      int ATtmp = n.getData();
      initAID(AIDtmp);
      ApplicationHandle apph=reg.registerApplication(this,out,AIDtmp,SIDtmp,ATtmp);
      //System.out.println(CL+": AID="+AIDtmp+",SID="+SIDtmp+",AT="+ATtmp);
      while(!exit)
      {
	AppEventMessage m;
	try
	{
	  m=n.receive();
	}
	catch(IOException e)
	{
	  //System.err.println(CL+": "+e);
	  e.printStackTrace();
	  System.out.println(CL+": IOException!: removing application");
	  m=null;
	  lapps.terminated(AID);	
	  stop();
	  break;
	}
	if(m!=null)
	{
	  handleAPPEVENT(m);
	}
	else
	{
	  System.err.println(CL+": null message received!: ignoring");
	}
      }
    }// run ________________________________________________________________

    
    public void stop()
    {
      //System.out.println(CL+".stop()");
      exit=true;
      out.stop();
      n.close();
    }// stop _______________________________________________________________


}// AppThreadIn ////////////////////////////////////////////////////////////

