// $Id: ComThread.java,v 1.6 1998/11/03 22:17:04 beca Exp $
/*
File: ComThread.java
Component: Server
Date		Author		Changes
Aug 22 96	Lukasz Beca	Created
*/


package webwisdom.tango.threads;


import java.lang.*;
import java.util.*;
import webwisdom.tango.messages.Message;
import webwisdom.tango.structures.MessageQueue;
import webwisdom.tango.threads.ThreadOut;
import webwisdom.tango.structures.ComSessionTable;


/**Server thread containing all outgoing threads (ThradOut).*/
public class ComThread extends Thread
{
    private static final String CL="ComThread";


    //private Vector out;
    //private Vector UIDVector;
    
    private Hashtable threadTable;
    private MessageQueue q;
    private ComSessionTable table;
  
    
    public ComThread()
    {
      super();
//      out = new Vector();
//      UIDVector = new Vector();

      threadTable = new Hashtable();
      q = new MessageQueue();
      table = new ComSessionTable();
    }// ComThread __________________________________________________________


    public void run()
    {
      System.out.println(CL+".run()");
      while(true)
      {
	//System.out.println(CL+": getting message from queue");
  	Message m=q.getMessage();
	table.putMessage(m);
      }
    }// run ________________________________________________________________


    public synchronized void addThread(ThreadOut tout,int UIDpar)
    {
      Integer tmp = new Integer(UIDpar);
 /*     if(UIDVector.contains(tmp))
      {
	System.out.println(CL+"addThread(): user "+UIDpar+
			   " already added!: ignoring");
	return;
      } 
      UIDVector.addElement(tmp);
      out.addElement(tout); */
      
      if(threadTable.containsKey(tmp))
      {
		     System.out.println(CL+"addThread(): user "+UIDpar+
			   " already added!: ignoring");
	       return;
      } 
      
      threadTable.put(tmp, tout);                                   
      
      System.out.println(CL+"addThread(): #threads="+threadTable.size());
    }// addThread __________________________________________________________


    public void removeThread(int UID)
    {
     /* int index=out.indexOf(tout);
      if(index!=-1)
      {
	out.removeElementAt(index);
	UIDVector.removeElementAt(index);	
	System.out.println(CL+".removeThread(): #thread="+out.size());
      }
      else
      {
	System.err.println(CL+"removeThread(): no such thread!: ignoring" );
      } */
      
      Integer tmpUID = new Integer(UID);
      
      
       if(!threadTable.contains(tmpUID))
      {
	      threadTable.remove(tmpUID);
	      System.out.println(CL+".removeThread(): #thread="+threadTable.size());
      }
      else
      {
	      System.err.println(CL+"removeThread(): no such thread!: ignoring" );
      }
      
      
      
      
    }// removeThread _______________________________________________________
  

    public ThreadOut getThread(int UIDpar)
    {
      /*int index=UIDVector.indexOf(new Integer(UIDpar));
      if(index!=-1)
      {
	return (ThreadOut)out.elementAt(index);
      }
      else
      {
	System.err.println(CL+".getThread(): no such user user!: "+UIDpar);
	return null;
      } */
      
      
      Integer tmpUID = new Integer(UIDpar);
     
      if(threadTable.containsKey(tmpUID))
      {
	return (ThreadOut) threadTable.get(tmpUID);
      }
      else
      {
	System.err.println(CL+".getThread(): no such user user!: "+UIDpar);
	return null;
      } 
      
      
      
      
    }// getThread __________________________________________________________
    
    
    public void sendTo(int UID,Message m)
    {
      ThreadOut tout=getThread(UID);
      if(tout!=null)
      {
	tout.putMessage(m);
      }		    
    }// sendTo _____________________________________________________________

    
    public synchronized void putMessage(Message m)
    {
      //System.out.println(CL+".putMessage()");
      q.putMessage(m);
    }// putMessage _________________________________________________________

 
    public Enumeration getAllThreads()
    {
      return threadTable.elements();
    }// getAllThreads ______________________________________________________
  
 
    public ComSessionTable getSessionTable()
    {
      return table;
    }// getSessionTable ____________________________________________________


}// ComThread //////////////////////////////////////////////////////////////


