// $Id: DemonThreadIn.java,v 1.4 1998/07/10 20:16:04 beca Exp $
/*
File: DemonThreadIn.java
Component: Plugin
Date		Author		Changes
Aug 24 96	Lukasz Beca	Created
*/


package webwisdom.tango.threads;


import java.net.*;
import java.io.*;
import webwisdom.tango.messages.*;
import webwisdom.tango.threads.ThreadOut;
import webwisdom.tango.consts.Const;
import webwisdom.tango.protocols.DemonProtocol;
import webwisdom.tango.structures.CentralServer;


/**Demon thread.*/
public class DemonThreadIn extends DemonProtocol implements Runnable
{
    private static final String CL="DemonThreadIn";


    private Thread th;   //reference to this thread 
    private boolean exit;
    private Net n;


    public DemonThreadIn(ThreadOut outparam,Socket s,CentralServer cspar)
    {
      super(outparam,cspar);     
      n=new Net(s);   
      th=new Thread(this);
      exit=false;
      th.start();
    }// DemonThreadIn ______________________________________________________
  

    public void run()
    {
      //System.out.println(CL+".run()");
      while(!exit)
      {
	Message m;
	try
	{
	  m=n.receive();
	}
	catch(IOException e)
	{
	  System.err.println(CL+": connection closed!");
	  e.printStackTrace();
	  m=null;
	  cs.connectionBrk();
	  break;
	}
	if(m!=null)
	{
	  int type=m.getType();
	  if(type==Const.EVENT)
	  {
	    handleEVENT((EventMessage)m);
	  }
	  else
	  {
	    switch(type)
	    {
	      case Const.COMMAND:
		handleCOMMAND((CommandMessage)m);
		break;
	      case Const.RASK:
		handleRASK((RaskMessage)m);
		break;
	      case Const.SUPD:
		handleSUPD((SupdMessage)m);
		break;
	      case Const.MASK:
		handleMASK((MaskMessage)m);
		break;
	      case Const.LOGACC:
		handleLOGACC((LogaccMessage)m);
		break;
	      case Const.JASK:
		handleJASK((JaskMessage)m);
		break;
	      case Const.JANS:
		handleJANS((JansMessage)m);
		break;
	      case Const.RANS:
		handleRANS((RansMessage)m);
		break;
	      case Const.MANS:
		handleMANS((MansMessage)m);
		break;
	      case Const.PING:
		handlePING((PingMessage)m);
		break;
	      default:
		System.err.println(CL+": message "+type+" not implemented!");
	    }
	  }      
	}
	else
	{
	  System.err.println(CL+": null message received!");
	}
      }
      n.close();
      // System.out.println(CL+"run(): exiting");
    }// run ________________________________________________________________


    public void stop()
    {
      //System.out.println(CL+".stop()");
      exit=true;
    }// stop _______________________________________________________________


}// DemonThreadIn //////////////////////////////////////////////////////////


